create
    definer = skoiypp@`%` procedure SP_GET_ASSETS_GALLERIES(IN _query varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = _query;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = " SELECT id_gallery, name,description,image,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_url,meta_watermark_image, default_id_album,position,update_date,register_date FROM galleries ";

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM galleries;
	SET @_limit_b = _limit_b;
END IF;

IF(_query <> '')
THEN
   SET @_query = CONCAT("%",_query,"%");
   SET sqlcommand = CONCAT(sqlcommand," WHERE name like @_query ");
END IF;

SET sqlcommand = CONCAT(sqlcommand," ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;
    
COMMIT;

END;

