create
    definer = skoiypp@`%` procedure SP_GET_BIZ_PROMOTION_VALIDATE(IN _code varchar(255), IN _id_plan int(10),
                                                                  IN _country_iso char(2), IN _id_user bigint)
BEGIN

DECLARE _email VARCHAR(255);
DECLARE _domain VARCHAR(255);

DECLARE _plan_active INT UNSIGNED;
DECLARE _plan_allow_promotions INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code, '' as description;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan) AND EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SELECT email,SUBSTRING_INDEX(email,'@',-1) into _email,_domain FROM users WHERE id_user = _id_user;
SELECT active,allow_promotions into _plan_active,_plan_allow_promotions FROM plans WHERE id_plan = _id_plan;





IF (_plan_active = 1)
THEN
	IF (_plan_allow_promotions = 1)
	THEN
        
        IF(_code <> '')
        THEN
				CALL SP_BIZ_PROMOTION_WITH_CODE(_code,_id_plan,_country_iso,_id_user,@return_code,@description,@id_promotion);
                
        ELSE
			
            SELECT count(1) into @totalPromotions FROM promotions WHERE id_promotion in (SELECT id_promotion FROM promotions_plans_related WHERE id_plan = _id_plan) AND 
			code_required = 0 and active = 1 AND (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()));
				
                IF(@totalPromotions > 0)
				THEN
						CALL SP_BIZ_PROMOTION(_id_plan,_country_iso,_email,_domain,@return_code,@description,@id_promotion);
						
				ELSE
					SELECT -50 as return_code, 'no promotion available' as description into @return_code,@description;
				END IF;
                
        END IF;

	IF(@return_code = 0)
    THEN
		SELECT 0 as return_code,id_promotion,promotion_type,percent_off,price_off,currency_iso,applied_on_renewal,applied_to_all_periods,billing_period FROM promotions p WHERE id_promotion = @id_promotion;
    ELSE
		SELECT @return_code as return_code,@description as description;
    END IF;
        
	ELSE 
        SELECT -51 as return_code, 'plan does not allow promotions' as description;
	END IF;
ELSE    
		SELECT -52 as return_code, 'plan not active' as description;
END IF;


ELSE
    SELECT -2 as return_code, 'plan or user does not exists' as description;
END IF;
        
COMMIT;

END;

