create
    definer = skoiypp@`%` procedure SP_GET_OTT_AVATARS(IN _field int(10), IN _query varchar(192),
                                                       IN _filter varchar(192), IN _limit_a int, IN _limit_b int)
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM avatars;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_avatar,id_sync,id_rev_sync,name,avatar,active,is_default,update_date, register_date FROM avatars a ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 0 AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
COMMIT;

END;

