create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_AVATARS_COUNT(IN _field int(10), IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_num_x = _filter;
SET @_id_group = _filter;


SET sqlcommand = "SELECT count(1) as total FROM avatars a ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_group = @_id_group AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE FN_GET_OTT_AVATARS_TOTAL_USERS(id_avatar) = @_num_x ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
   
COMMIT;

END;

