create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_AVATARS_GROUPS(IN _field int(10), IN _query varchar(192),
                                                                       IN _filter varchar(192), IN _limit_a int,
                                                                       IN _limit_b int, IN _order_by int(10),
                                                                       IN _order int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM avatars;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_group,name,FN_GET_OTT_NUM_AVATARS_ON_GROUP(id_group) as total_avatars,position, update_date, register_date FROM avatars_groups a ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_group = @_id_group AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

		CASE
			WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name DESC ");
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name ASC ");
			WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY position DESC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY position ASC ");            
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC  ");
		END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
COMMIT;

END;

