create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_FREEBIE_WHITELIST_COUNT(IN _field int(10),
                                                                                IN _field_snd int(10),
                                                                                IN _field_trd int(10),
                                                                                IN _query varchar(192),
                                                                                IN _filter varchar(192),
                                                                                IN _filter_snd varchar(192),
                                                                                IN _filter_trd varchar(192))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SET @id_freebie = _filter;
SET @id = _filter_snd;
SET @active = _filter_snd;
SET @type = _filter_snd;
SET @vvalue = CONCAT("%",_filter_snd,"%");

IF EXISTS(SELECT id_freebie FROM freebies WHERE id_freebie = _filter)
THEN

	SET sqlcommand = "SELECT count(1) as total FROM freebies_whitelist_related WHERE id_freebie = @id_freebie ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id = @id ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (value like @vvalue ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (type like @type ) ");    
		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt; 

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

