create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_LEADERBOARDS_TEAMS_AVATARS(IN _id_leaderboard int(10),
                                                                                   IN _field int(10),
                                                                                   IN _field_snd int(10),
                                                                                   IN _field_trd int(10),
                                                                                   IN _query varchar(192),
                                                                                   IN _filter varchar(192),
                                                                                   IN _filter_snd varchar(192),
                                                                                   IN _filter_trd varchar(192),
                                                                                   IN _order_by int(10),
                                                                                   IN _order int(10),
                                                                                   IN _limit_a int(10),
                                                                                   IN _limit_b int(10))
BEGIN

-- CALL SP_GET_OTT_LEADERBOARDS_TEAMS_AVATARS(1,0,0,0,'','','','',0,0,0,10)

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM leaderboards_teams_avatars;
	SET @_limit_b = _limit_b;
END IF;

SET @id_leaderboard = _id_leaderboard;
SET @id_asset = _filter_snd;
SET @active = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

	SET sqlcommand = "SELECT id_avatar,id_leaderboard,name,id_asset,filename,avatar,active,update_date,register_date FROM leaderboards_teams_avatars WHERE id_leaderboard = @id_leaderboard ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_asset = @id_asset ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");                    

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
    
    CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1  ");
	END CASE;

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active DESC");         
    
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
        
COMMIT;

END;

