create
    definer = skoiypp@`%` procedure SP_GET_OTT_LEADERBOARDS_USERS(IN _id_leaderboard int(10), IN _field int(10),
                                                                  IN _field_snd int(10), IN _field_trd int(10),
                                                                  IN _query varchar(192), IN _filter varchar(192),
                                                                  IN _filter_snd varchar(192),
                                                                  IN _filter_trd varchar(192), IN _order_by int(10),
                                                                  IN _order int(10), IN _limit_a int(10),
                                                                  IN _limit_b int(10))
BEGIN



DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM users u, leaderboards_results lr WHERE lr.id_leaderboard = _id_leaderboard AND u.id_user = lr.id_user;
	SET @_limit_b = _limit_b;
END IF;

SET @id_leaderboard = _id_leaderboard;
SET @id_user = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

	SET sqlcommand = "SELECT u.id_user,u.name,(SELECT count(1) FROM leaderboards_users_friends WHERE id_user = u.id_user) as total_friends,sum(score) as score,sum(time) as time,lr.update_date,lr.register_date FROM users u, leaderboards_results lr WHERE u.id_user = lr.id_user AND id_leaderboard = @id_leaderboard ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (u.id_user = @id_user ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
    
    CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1  ");
	END CASE;

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY lr.register_date ASC");

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY lr.register_date DESC");
    
	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
        
COMMIT;

END;

