create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PLANS(IN _field int(10), IN _field_snd int(10),
                                                              IN _field_trd int(10), IN _query varchar(192),
                                                              IN _filter varchar(192), IN _filter_snd varchar(192),
                                                              IN _filter_trd varchar(192), IN _order_by int(10),
                                                              IN _order int(10), IN _limit_a int(10),
                                                              IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM plans;
	SET @_limit_b = _limit_b;
END IF;

SET @id_plan = _filter_snd;
SET @active = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

	SET sqlcommand = "SELECT id_plan,plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
		trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
		unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,FN_GET_OTT_PLAN_TOTAL_USERS(id_plan) as total_users,update_date,register_date FROM plans WHERE 1=1 ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan = @id_plan ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");                    

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
    
    CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND management_name like @_name ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1  ");
	END CASE;

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY plan_type ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");
	WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");  
	WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_users ASC");      

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY plan_type DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active DESC");         
	WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name DESC");  
	WHEN _order_by = 11004 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_users DESC");      
 

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
        
COMMIT;

END;

