create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PROMOTION_EMAILS(IN _field int(10), IN _field_snd int(10),
                                                                         IN _field_trd int(10), IN _query varchar(192),
                                                                         IN _filter varchar(192),
                                                                         IN _filter_snd varchar(192),
                                                                         IN _filter_trd varchar(192),
                                                                         IN _limit_a int(10), IN _limit_b int(10),
                                                                         IN _order int(10), IN _order_by int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM promotions_emails_related;
	SET @_limit_b = _limit_b;
END IF;

SET @id_promotion = _filter;
SET @id = _filter_snd;
SET @email = CONCAT("%",_filter_snd,"%");

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF EXISTS(SELECT id_promotion FROM promotions WHERE id_promotion = _filter)
THEN

	SET sqlcommand = "SELECT id,id_promotion,email,active,register_date FROM promotions_emails_related WHERE id_promotion = @id_promotion ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id = @id ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (email like @email ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY email ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");      

	WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY email DESC");
	WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active DESC");      

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

