create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PROMOTION_USED(IN _field int(10), IN _field_snd int(10),
                                                                       IN _field_trd int(10), IN _query varchar(192),
                                                                       IN _filter varchar(192),
                                                                       IN _filter_snd varchar(192),
                                                                       IN _filter_trd varchar(192),
                                                                       IN _order_by int(10), IN _order int(10),
                                                                       IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM promotions_used;
	SET @_limit_b = _limit_b;
END IF;

SET @id_promotion = _filter;
SET @id = _filter_snd;
SET @email = CONCAT("%",_filter_snd,"%");
SET @id_code = _filter_snd;
SET @claimed_by_user = _filter_snd;
SET @id_plan = _filter_snd;
SET @pcode = CONCAT("%",_filter_snd,"%");

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET @return_code = 0;


	SET sqlcommand = "SELECT id,id_code,(SELECT code FROM promotions_codes_related WHERE id_code = pu.id_code) as code,id_promotion,id_plan,FN_GET_OTT_PULL_PLAN(id_plan,'MNAME') as plan,claimed_by_user,FN_GET_OTT_PULL_USER(claimed_by_user,'EMAIL') as claimed_email,claimed_date,register_date FROM promotions_used  pu WHERE 1=1 ";

	IF(_filter > 0)
	THEN
			IF EXISTS(SELECT id_promotion FROM promotions WHERE id_promotion = _filter)
			THEN
				SET sqlcommand =  CONCAT(sqlcommand, " AND id_promotion = @id_promotion ");
			ELSE
				SET @return_code = -2;
			END IF;
	END IF;

IF(@return_code = 0)
THEN

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id = @id ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_code = @id_code ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND ((SELECT code FROM promotions_codes_related WHERE id_code = pu.id_code) like @pcode ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan like @id_plan ) ");
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (claimed_by_user = @claimed_by_user ) ");
			WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_OTT_PULL_USER(claimed_by_user,'EMAIL') like @email ) ");

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY code ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY plan ASC");      

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY code DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY plan DESC");      

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
    
ELSE
	SELECT @return_code as return_code;
END IF;

        
COMMIT;

END;

