create
    definer = skoiypp@`%` procedure SP_GET_OTT_SCAN_CODES(IN _field int(10), IN _field_snd int(10),
                                                          IN _field_trd int(10), IN _query varchar(192),
                                                          IN _filter varchar(192), IN _filter_snd varchar(192),
                                                          IN _filter_trd varchar(192), IN _order_by int(10),
                                                          IN _order int(10), IN _limit_a int(10), IN _limit_b int(10))
BEGIN



DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM scans_codes_related;
	SET @_limit_b = _limit_b;
END IF;

SET @id_scan = _filter;
SET @id_code = _filter_snd;
SET @active = _filter_snd;
SET @unlimited = _filter_snd;
SET @pcode = CONCAT("%",_filter_snd,"%");
SET @_query = CONCAT("%",_query,"%");

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF EXISTS(SELECT id_scan FROM scans WHERE id_scan = _filter)
THEN

	SET sqlcommand = "SELECT id_code,id_scan,code,FN_GET_OTT_TOTAL_SCAN_USED(id_code) as total,quantity,unlimited,active,max_scans_per_user,daily_limit_per_user,scan_interval_per_user,register_date FROM scans_codes_related WHERE id_scan = @id_scan ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_code = @id_code ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");   
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (code like @pcode ) ");
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (unlimited = @unlimited ) ");  

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	SET sqlcommand =  CONCAT(sqlcommand, " AND (code like @_query) ");

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY code ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");
	WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY quantity ASC");  
	WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total ASC");   

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY code DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active DESC");         
	WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY quantity DESC");  
	WHEN _order_by = 11004 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total DESC");  

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

