create
    definer = skoiyottdebug2@`%` procedure SP_GET_OTT_USERS(IN _field int(10), IN _field_snd int(10),
                                                            IN _field_trd int(10), IN _query varchar(192),
                                                            IN _filter varchar(192), IN _filter_snd varchar(192),
                                                            IN _filter_trd varchar(192), IN _limit_a int,
                                                            IN _limit_b int, IN _order_by int(10), IN _order int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM users;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @id_user = _filter_snd;
SET @email = _filter_snd;
SET @id_plan = _filter_snd;
SET @verified = _filter_snd;
SET @plan_stripped = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_user,id_plan,FN_GET_OTT_PLAN(id_plan,1) as plan,FN_GET_OTT_PLAN(id_plan,2) as plan_stripped,FN_GET_OTT_USER_TOTAL_PROFILES(id_user) as total_profiles,full_name as name,email,gender,birthdate,identification,tax_number,nationality,country_iso,city,zipcode,phone,active,verified,last_login,update_date, register_date FROM users u ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_user = @id_user ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (email = @email ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan = @id_plan ) ");  
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_OTT_PLAN(id_plan,2) = @plan_stripped ) ");              
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (verified = @verified ) "); 
            ELSE SET sqlcommand = CONCAT(sqlcommand, "");
		END CASE;
	END IF;

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE full_name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

		CASE
			WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY full_name DESC ");
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY full_name ASC ");
			WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");
			WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_plan DESC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_plan ASC ");
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY full_name ASC  ");
		END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
COMMIT;

END;

