create
    definer = skoiypp@`%` procedure SP_GET_OTT_USERS_PERFORMANCE(IN _field int(10), IN _field_snd int(10),
                                                                 IN _field_trd int(10), IN _query varchar(192),
                                                                 IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                 IN _filter_trd varchar(192),
                                                                 IN _limit_trd_a varchar(255),
                                                                 IN _limit_trd_b varchar(255))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


IF(_field = 1)
THEN

SET @gender = _filter_trd;
SET @verified = _filter_trd;
SET @days = _filter_trd;
SET @_year = _filter_trd;
SET @_limit_date_a = date(_limit_trd_a);
SET @_limit_date_b = date(_limit_trd_b);
    
    IF(_field_snd = 0) 
	THEN
		SET sqlcommand = "SELECT count(1) as total,'' as value FROM users WHERE 1=1 ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (verified = @verified ) ");                
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b) ");  
				WHEN _field_trd = 1003 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");           
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " ");
	END IF;
    
	
	IF(_field_snd = 1) 
	THEN
		SET sqlcommand = "SELECT count(1) as total, date(register_date) as value FROM users  WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b ) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");   
                WHEN _field_trd = 1003 THEN SET sqlcommand = "SELECT count(1) as total, date(verified_date) as value FROM users WHERE (verified = @verified) GROUP by date(verified_date)";
				WHEN _field_trd = 1004 THEN SET sqlcommand = "SELECT count(1) as total, date(verified_date) as value FROM users WHERE verified = 1 AND (date(verified_date) BETWEEN @_limit_date_a AND @_limit_date_b )  GROUP by date(verified_date) ";            
			END CASE;
		END IF;

        IF(_field_trd not in (1003,1004))
        THEN
       		SET sqlcommand = CONCAT(sqlcommand, " GROUP by date(register_date)"); 
        END IF;
        
	END IF;
    
	
	IF(_field_snd = 2) 
	THEN
		SET sqlcommand = "SELECT count(1) as total, hour(register_date) as value FROM users  WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b ) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");           
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by hour(register_date)");
	END IF;
    
    
    IF(_field_snd = 3) 
	THEN
		SET sqlcommand = "SELECT count(1) as total, gender as value FROM users  WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b ) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");           
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by gender");
	END IF;
    
	
	IF(_field_snd = 4) 
	THEN
		SET sqlcommand = "SELECT count(1) as total, month(register_date) as value FROM users WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");      
                WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND year(register_date) = @_year ");  
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by month(register_date)");
	END IF;
    
    
    SET @sqlcommand = sqlcommand;
   
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;    

END IF;


IF(_field = 2)
THEN

SET @gender = _filter_snd;
SET @days = _filter_trd;
SET @_limit_date_a = date(_limit_trd_a);
SET @_limit_date_b = date(_limit_trd_b);
SET @_limit_datetime_a = _limit_trd_a;
SET @_limit_datetime_b = _limit_trd_b;

    
    IF(_field_snd = 0) 
	THEN
		SET sqlcommand = "SELECT count(1) as total, '' value FROM users WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) = (date(now()) - INTERVAL @days DAY) GROUP BY id) as tt1) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) BETWEEN @_limit_date_a AND @_limit_date_b GROUP BY id) as tt2) ");  
				WHEN _field_trd = 1003 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE FN_GET_OTT_OAUTH_ACCESS_DATE(data) BETWEEN @_limit_datetime_a AND @_limit_datetime_b GROUP BY id) as tt2) ");  


				WHEN _field_trd = 1011 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND gender = @gender AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) = (date(now()) - INTERVAL @days DAY) GROUP BY id) as tt3) ");  
				WHEN _field_trd = 1012 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND gender = @gender AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) BETWEEN @_limit_date_a AND @_limit_date_b GROUP BY id) as tt4) ");  
				WHEN _field_trd = 1013 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND gender = @gender AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) BETWEEN @_limit_datetime_a AND @_limit_datetime_b GROUP BY id) as tt4) ");  

          
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " ");
	END IF;

    SET @sqlcommand = sqlcommand;
   
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;    

END IF;


IF(_field = 3)
THEN

SET @gender = _filter_snd;
SET @days = _filter_trd;
SET @_limit_date_a = date(_limit_trd_a);
SET @_limit_date_b = date(_limit_trd_b);
SET @_limit_datetime_a = _limit_trd_a;
SET @_limit_datetime_b = _limit_trd_b;

    
    IF(_field_snd = 0) 
	THEN

		SET sqlcommand = "SELECT count(distinct id_user) as total, date(update_date) as value FROM (SELECT id_user,update_date FROM users_plans_related WHERE active = 1 GROUP by id_user) t WHERE 1=1 ";
		SET sqlcommand =  CONCAT(sqlcommand, " ");  
        
		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(update_date) BETWEEN @_limit_date_a AND @_limit_date_b) ");  
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by date(update_date)");
	END IF;
	
    IF(_field_snd = 1) 
	THEN
		SET sqlcommand = "SELECT count(distinct id_user) as total, '' as value FROM users_plans_related WHERE active = 1 ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(update_date) BETWEEN @_limit_date_a AND @_limit_date_b) ");  
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " ");
	END IF;
    

    SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;    

END IF;


IF(_field = 4)
THEN

SET @_limit_date_a = date(_limit_trd_a);
SET @_limit_date_b = date(_limit_trd_b);

		SET sqlcommand = 
        "
        SELECT count(1) as total, '< 20' as value FROM users WHERE TIMESTAMPDIFF(year,birthdate, date(now())) < 20 AND year(birthdate) > 1900 AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b )
			UNION
		SELECT count(1) as total, '20 - 30' as value FROM users WHERE TIMESTAMPDIFF(year,birthdate, date(now())) >= 20 AND TIMESTAMPDIFF(year,birthdate, date(now())) < 30 AND year(birthdate) > 1900 AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b )
			UNION
		SELECT count(1) as total, '30 - 40' as value FROM users WHERE TIMESTAMPDIFF(year,birthdate, date(now())) >= 30 AND TIMESTAMPDIFF(year,birthdate, date(now())) < 40 AND year(birthdate) > 1900 AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b )
			UNION
		SELECT count(1) as total, '40 - 50' as value FROM users WHERE TIMESTAMPDIFF(year,birthdate, date(now())) >= 40 AND TIMESTAMPDIFF(year,birthdate, date(now())) < 50 AND year(birthdate) > 1900 AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b )
			UNION
		SELECT count(1) as total,'50 - 60' as value FROM users WHERE TIMESTAMPDIFF(year,birthdate, date(now())) >= 50 AND TIMESTAMPDIFF(year,birthdate, date(now())) < 60 AND year(birthdate) > 1900 AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b )
			UNION
		SELECT count(1) as total, '> 60' as value FROM users WHERE TIMESTAMPDIFF(year,birthdate, date(now())) > 60 AND year(birthdate) > 1900 AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b )
        ";
        
	SET @sqlcommand = sqlcommand;
   
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;    
    
END IF;

IF(_field not in (1,2,3,4))
THEN
	SELECT 0 as total, '' as value;
END IF;

COMMIT;

END;

