create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_USER_TRANSACTIONS(IN _id_user bigint, IN _field int(10),
                                                                          IN _field_snd int(10), IN _field_trd int(10),
                                                                          IN _query varchar(192),
                                                                          IN _filter varchar(192),
                                                                          IN _filter_snd varchar(192),
                                                                          IN _filter_trd varchar(192),
                                                                          IN _order_by int(10), IN _order int(10),
                                                                          IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM user_transactions WHERE id_user = _id_user;
END IF;

SET @_query = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @_id_user = _id_user;
SET @_id_transaction = _filter_snd;
SET @_promotion_code = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

  SET sqlcommand = "SELECT id_transaction,id_user,payment_service,description,item_id,item_type,transaction_id,transaction_status,transaction_created_at,transaction_paid_at,total_amount,total_discount,promotion_code,currency_iso,register_date, 
									FN_IS_NULL((SELECT entity FROM transactions_refmb tmb WHERE tmb.transaction_id = ut.transaction_id limit 0,1)) as entity,
                                    FN_IS_NULL((SELECT reference FROM transactions_refmb tmb WHERE tmb.transaction_id = ut.transaction_id limit 0,1)) as reference,
                                    FN_IS_NULL((SELECT amount FROM transactions_refmb tmb WHERE tmb.transaction_id = ut.transaction_id limit 0,1)) as amount,
                                    FN_IS_NULL((SELECT last4 FROM transactions_stripe stripe WHERE stripe.transaction_id = ut.transaction_id limit 0,1)) as last4
                                    FROM user_transactions ut WHERE id_user = @_id_user "; 
                                    
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_transaction = @_id_transaction ) ");   
            WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (promotion_code = @_promotion_code ) ");   
		END CASE;
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (description like @_query) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

		CASE
			WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY description DESC ");
			WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_amount DESC");            
			WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_discount DESC ");
			WHEN _order_by = 11004 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY promotion_code DESC ");
            
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY description ASC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");  
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_amount ASC");            
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_discount ASC ");
			WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY promotion_code ASC ");
            
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC  ");
		END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    

COMMIT;

END;

