create
    definer = skoiypp@`%` procedure SP_GET_OTT_USER_TRANSACTIONS_COUNT(IN _id_user bigint, IN _field int(10),
                                                                       IN _field_snd int(10), IN _field_trd int(10),
                                                                       IN _query varchar(192), IN _filter varchar(192),
                                                                       IN _filter_snd varchar(192),
                                                                       IN _filter_trd varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_query = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @_id_user = _id_user;
SET @_id_transaction = _filter_snd;
SET @_promotion_code = _filter_snd;
  
  SET sqlcommand = "SELECT count(1) as total FROM user_transactions WHERE id_user = @_id_user "; 
                                    
	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_transaction = @_id_transaction ) ");   
            WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (promotion_code = @_promotion_code ) ");   
		END CASE;
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (description like @_query OR transaction_id like @_query) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
        
COMMIT;

END;

