create
    definer = skoiypp@`%` procedure SP_GET_SSO_AUTH_DEVICE()
BEGIN

DECLARE _device_code VARCHAR(255);
DECLARE _user_code VARCHAR(255);

DECLARE _verification_uri VARCHAR(255);
DECLARE _verification_uri_complete VARCHAR(255);

DECLARE p_last_id BIGINT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SELECT verification_uri,verification_uri_complete into _verification_uri,_verification_uri_complete FROM oauth2_settings LIMIT 0,1;

DELETE FROM oauth2_device WHERE DATE_ADD(register_date, INTERVAL expired_in second) <= now() AND state = 0 AND id_user = 0;

			SELECT FN_GENERATE_SSO_CODE('',1,1,1,65) into _device_code;
			WHILE NOT EXISTS(SELECT count(1) FROM oauth2_device WHERE device_code = _device_code)
			DO
				SELECT FN_GENERATE_SSO_CODE('',1,1,1,65) into _device_code;
			END WHILE;
			SELECT FN_GENERATE_SSO_CODE('',1,0,0,6) into _user_code;
			WHILE NOT EXISTS(SELECT count(1) FROM oauth2_device WHERE user_code = _user_code)
			DO
				SELECT FN_GENERATE_SSO_CODE('',1,0,0,6) into _user_code;
			END WHILE;
        
			INSERT into oauth2_device(expired_in,device_code,user_code,polling_interval,register_date)
            VALUES(1800,_device_code,_user_code,5,now());
            SET p_last_id = last_insert_id();
            
            SELECT id,expired_in,device_code,user_code,polling_interval,_verification_uri as verification_uri,_verification_uri_complete as verification_uri_complete 
            FROM oauth2_device WHERE id = p_last_id;
            
COMMIT;

END;

