create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT_LIVE_SERVER_SETTINGS(IN _id_account INT, IN _id_live INT,
                                                                        IN _name VARCHAR(255), IN _dvr TINYINT(1),
                                                                        IN _record TINYINT(1))
BEGIN

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;
IF EXISTS (SELECT id_account from accounts_live_server_settings where id_account = _id_account AND id_live = _id_live)
THEN
	UPDATE accounts_live_server_settings SET name = _name, dvr = _dvr, record = _record WHERE id_account = _id_account AND id_live = _id_live;
	SELECT 0 as return_code;
ELSE
    SELECT -2 as return_code;
END IF;
COMMIT;

END;

