create
    definer = skoiypp@`%` procedure SP_SET_ACCOUNT_TEAMS(IN _id_account int(10), IN _id_team int(10),
                                                         IN _name varchar(255), IN _name_stripped varchar(255),
                                                         IN _description varchar(255), IN _position int(10),
                                                         IN _active int(10))
BEGIN




DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_account FROM accounts WHERE id_account = _id_account)
THEN

    IF(_id_team = 0 OR _id_team = -1)
    THEN
            INSERT into teams(id_account,name,name_stripped,description,position,active,register_date) VALUES(_id_account,_name,_name_stripped,_description,_position,_active,now());        
            SET p_last_id = last_insert_id();
            SELECT id_team,id_account,name,name_stripped,description,(SELECT count(1) FROM users_teams_related WHERE id_team = t.id_team) as total,(SELECT count(1) FROM users_guests_teams_related WHERE id_team = t.id_team) as total_guests,position,active,update_date,register_date FROM teams t WHERE id_team = p_last_id; 
    ELSE       
         IF EXISTS (SELECT id_team FROM teams WHERE id_team = _id_team AND id_account = _id_account)
         THEN
    		UPDATE teams SET name = _name,name_stripped = _name_stripped,description = _description,position = _position,active = _active, update_date = now() WHERE id_team = _id_team AND id_account = _id_account;
			SELECT id_team,id_account,name,name_stripped,description,(SELECT count(1) FROM users_teams_related WHERE id_team = t.id_team) as total,(SELECT count(1) FROM users_guests_teams_related WHERE id_team = t.id_team) as total_guests,position,active,update_date,register_date FROM teams t WHERE id_team = _id_team AND id_account = _id_account; 
         ELSE
            SELECT -2 as return_code;
         END IF;
    END IF;
    
    ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

