create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_CUSTOM_FIELDS_VARIANTS(IN _id_asset int(10), IN _id_key int(10),
                                                                         IN _variant_value varchar(255),
                                                                         IN _id_position int(10))
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_asset FROM assets WHERE id_asset = _id_asset) AND EXISTS (SELECT id_key FROM assets_custom_fields_keys WHERE id_key = _id_key)
THEN

    IF NOT EXISTS(SELECT id_asset FROM assets_custom_fields_related WHERE id_asset = _id_asset AND id_key = _id_key)
    THEN
        INSERT INTO assets_custom_fields_related(id_asset,id_key,variant_value,position,register_date) VALUES(_id_asset,_id_key,_variant_value,_id_position,now());
    ELSE
        UPDATE assets_custom_fields_related SET variant_value = _variant_value, position = _id_position, update_date = now() WHERE id_asset = _id_asset AND id_key = _id_key;
    END IF;
    
    SELECT id_variant, id_asset,b.id_key, name,name_stripped, variant_value,position, a.register_date FROM assets_custom_fields_related a, assets_custom_fields_keys b
    WHERE a.id_key = b.id_key AND a.id_asset = _id_asset AND b.id_key = _id_key;     

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

