create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_GALLERIES(IN _id_gallery int, IN _name varchar(192),
                                                            IN _description text, IN _image varchar(255),
                                                            IN _image_align varchar(255), IN _image_title varchar(255),
                                                            IN _image_alter_text varchar(255),
                                                            IN _meta_title varchar(255), IN _meta_description text,
                                                            IN _meta_image varchar(255), IN _meta_keywords varchar(255),
                                                            IN _meta_url varchar(255),
                                                            IN _meta_watermark_image varchar(255),
                                                            IN _default_id_album int)
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET p_last_id = 0;

IF(_id_gallery = 0 OR _id_gallery = -1)
THEN
   INSERT into galleries(name,description,image,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_url,meta_watermark_image,default_id_album,register_date) VALUES(_name,_description,_image,_image_align,_meta_title,_meta_description,_meta_image,_image_title,_image_alter_text,_meta_keywords,_meta_url,_meta_watermark_image,_default_id_album,now());
   SET p_last_id = last_insert_id();
   SELECT id_gallery,name,description,image,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_url,meta_watermark_image,default_id_album,position, register_date FROM galleries WHERE id_gallery = p_last_id;
ELSE
  IF EXISTS (SELECT id_gallery FROM galleries WHERE id_gallery = _id_gallery)
  THEN     
      SELECT FN_SP_SET_PUBLISH_ASSETS_SYNC_UPDATE(30,_id_gallery) into _empty;  
      UPDATE galleries SET name = _name,description = _description,default_id_album = _default_id_album, image = _image,image_align = _image_align,meta_title = _meta_title,meta_description = _meta_description,meta_image = _meta_image,image_title = _image_title,image_alter_text = _image_alter_text,meta_keywords = _meta_keywords,meta_url = _meta_url,meta_watermark_image = _meta_watermark_image,default_id_album = _default_id_album, update_date = now() WHERE id_gallery = _id_gallery;
      SELECT id_gallery,name,description,image,image_align,meta_title,meta_description,meta_image,image_title,image_alter_text,meta_keywords,meta_url,meta_watermark_image,default_id_album,position, register_date FROM galleries WHERE id_gallery = _id_gallery;
  ELSE
    SELECT -2 as return_code;
  END IF;
END IF;  
  
COMMIT;

END;

