create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_PLAYLISTS_CUSTOM_FIELDS_VARIANTS(IN _id_playlist int(10),
                                                                                   IN _id_key int(10),
                                                                                   IN _variant_value varchar(255),
                                                                                   IN _id_position int(10))
BEGIN

DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_playlist FROM assets_playlists WHERE id_playlist = _id_playlist) AND EXISTS (SELECT id_key FROM assets_playlists_custom_fields_keys WHERE id_key = _id_key)
THEN

    IF NOT EXISTS(SELECT id_playlist FROM assets_playlists_custom_fields_related WHERE id_playlist = _id_playlist AND id_key = _id_key)
    THEN
        INSERT INTO assets_playlists_custom_fields_related(id_playlist,id_key,variant_value,position,register_date) VALUES(_id_playlist,_id_key,_variant_value,_id_position,now());
    ELSE
        UPDATE assets_playlists_custom_fields_related SET variant_value = _variant_value, position = _id_position, update_date = now() WHERE id_playlist = _id_playlist AND id_key = _id_key;
    END IF;
    
    SELECT id_variant, id_playlist,b.id_key, name,name_stripped, variant_value,position, a.register_date FROM assets_playlists_custom_fields_related a, assets_playlists_custom_fields_keys b
    WHERE a.id_key = b.id_key AND a.id_playlist = _id_playlist AND b.id_key = _id_key;     

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

