create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_TRANSFER(IN _id_transfer int, IN _id_directory int,
                                                           IN _management_name varchar(255), IN _name varchar(255),
                                                           IN _description text, IN _code varchar(255),
                                                           IN _password varchar(255), IN _end_date datetime,
                                                           IN _active tinyint(1), IN _image_optimization varchar(255),
                                                           IN _watermark_image varchar(255), IN _settings text,
                                                           IN _view_only tinyint(1), IN _verify_identity tinyint(1),
                                                           IN _compress_enabled tinyint(1), IN _content_type tinyint(1))
BEGIN
	
	
	
DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;



START TRANSACTION;

IF(_id_transfer = 0 OR _id_transfer = -1)
THEN

			SET @_prefix = '';
			SET @_numbers = 1;
			SET @_lowercase = 0;
			SET @_uppercase = 0;
			SET @_length = 10;
			
			SELECT FN_GENERATE_RANDOM_CODE(@_prefix,@_numbers,@_lowercase,@_uppercase,@_length) into _code;
			WHILE NOT EXISTS(SELECT count(1) FROM assets_transfers WHERE code = @_code)
			DO
				SELECT FN_GENERATE_RANDOM_CODE(@_prefix,@_numbers,@_lowercase,@_uppercase,@_length) into _code;
			END WHILE;

	IF NOT EXISTS(SELECT id_transfer FROM assets_transfers WHERE code = _code)
	THEN
	   INSERT INTO assets_transfers(id_directory,management_name,name,description,code,password,end_date,active,content_type,image_optimization,watermark_image,settings,view_only,verify_identity,compress_enabled,register_date) VALUES(_id_directory,_management_name,_name,_description,_code,_password,_end_date,_active,_content_type,_image_optimization,_watermark_image,_settings,_view_only,_verify_identity,_compress_enabled,now());
	   SET p_last_id = last_insert_id();
    SELECT id_transfer, id_directory,management_name,name,description, code, password, end_date,active,FN_GET_ASSETS_NUM_ON_TRANSFERS(id_transfer) as total_content,register_date,
	FN_GET_ASSETS_TRANSFER_COVER_IMAGE(id_transfer) as cover_image, content_type,image_optimization,watermark_image,settings,view_only,verify_identity,compress_enabled
	FROM assets_transfers WHERE id_transfer = p_last_id;
	ELSE
		SELECT -2 as return_code;
	END IF;
ELSE
	IF EXISTS (SELECT id_transfer FROM assets_transfers WHERE id_transfer = _id_transfer)
	THEN	   
		UPDATE assets_transfers SET id_directory = _id_directory, management_name = _management_name,name = _name,description = _description, password = _password, end_date = _end_date, active = _active, image_optimization = _image_optimization, watermark_image = _watermark_image,settings = _settings,view_only = _view_only, verify_identity = _verify_identity,compress_enabled = _compress_enabled, update_date = now() WHERE id_transfer = _id_transfer;
    SELECT id_transfer, id_directory,management_name,name,description, code, password, end_date,active,FN_GET_ASSETS_NUM_ON_TRANSFERS(id_transfer) as total_content,register_date,
	FN_GET_ASSETS_TRANSFER_COVER_IMAGE(id_transfer) as cover_image, content_type,image_optimization,watermark_image,settings,view_only,verify_identity,compress_enabled 
	FROM assets_transfers WHERE id_transfer = _id_transfer;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;  
  
COMMIT;

END;

