create
    definer = `youon-vrt20`@`%` procedure SP_SET_AUDIENCES_CREATE_COMMAND(IN _id_audience int(10))
BEGIN

DECLARE _sqlcommand text;


DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_option_value varchar(255);
DECLARE c_id_group INT;
DECLARE c_id_audience INT;
DECLARE c_id_option INT;

DECLARE r_value_type INT;
DECLARE r_operator_type INT;
DECLARE r_sqlcommand TEXT;

DECLARE cursor_audience CURSOR FOR SELECT id_group,id_audience,id_option,option_value FROM audiences_groups_options_related WHERE id_audience = _id_audience ORDER by id_group;

DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;


DECLARE exit handler for sqlexception
  BEGIN
    
	  SELECT -1 as return_code;
    rollback;
  END;


SET _sqlcommand = 'SELECT count(1) into @atotal FROM users  ';
SET @nrow = 0;
 

    OPEN cursor_audience;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_audience INTO c_id_group,c_id_audience,c_id_option,c_option_value;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
    
    
		SELECT operator_type into r_operator_type FROM audiences_groups WHERE id_audience = c_id_audience AND id_group = c_id_group;
        SELECT sqlcommand,value_type into r_sqlcommand,r_value_type FROM audiences_options WHERE id_option = c_id_option;
        
       
        
        IF(@nrow = 0)
        THEN
			SET _sqlcommand = CONCAT_WS(' ',_sqlcommand,' WHERE ');
            SET @nrow = 1;
        ELSE
			IF(r_operator_type = 0)
            THEN
				SET _sqlcommand = CONCAT_WS(' ',_sqlcommand,' OR ');
            ELSE
				SET _sqlcommand = CONCAT_WS(' ',_sqlcommand,' AND ');
            END IF;
        END IF;
        
	  IF(r_value_type = 0)
      THEN
			SET _sqlcommand = CONCAT_WS(' ',_sqlcommand,' ',r_sqlcommand);
      ELSE
			SET c_option_value = CONCAT('\'',c_option_value,'\'');
      		SET _sqlcommand = CONCAT_WS(' ',_sqlcommand,' ',r_sqlcommand, c_option_value,')');
      END IF;
      
      UPDATE audiences SET sqlcommand = _sqlcommand, update_date = now() WHERE id_audience = c_id_audience; 
      
	
    
      END LOOP read_loop;

    CLOSE cursor_audience;
 
 
 SELECT 0 as return_code;
 




END;

