create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_BIZ_PROMOTION_CODE_USED(IN _id_code int(10),
                                                                            IN _id_promotion int(10),
                                                                            IN _id_plan int(10),
                                                                            IN _country_iso char(2),
                                                                            IN _claimed_by_user bigint)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_promotion FROM promotions WHERE id_promotion = _id_promotion) AND EXISTS (SELECT id_code FROM promotions_codes_related WHERE id_code = _id_code)
THEN
  INSERT into promotions_codes_used(id_promotion,id_code,claimed_by_user,claimed_date,register_date) VALUES(_id_promotion,_id_code,_claimed_by_user,now(),now());
  SET p_last_id = last_insert_id();
  SELECT id,id_promotion,id_code,claimed_by_user,claimed_date,register_date FROM promotions_codes_used WHERE id = p_last_id;
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

