create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_BIZ_PROMOTION_USED(IN _id_promotion int(10), IN _code varchar(255),
                                                                       IN _id_plan int(10), IN _country_iso char(2),
                                                                       IN _id_user bigint)
BEGIN

DECLARE p_last_id INT UNSIGNED;

DECLARE _plan_active INT UNSIGNED;
DECLARE _plan_allow_promotions INT UNSIGNED;

-- DECLARE _quantity INT UNSIGNED;
-- DECLARE _unlimited INT UNSIGNED;
-- DECLARE _code_active INT UNSIGNED;
DECLARE _id_code INT UNSIGNED;

DECLARE _email VARCHAR(255);
DECLARE _domain VARCHAR(255);

-- DECLARE _totalTempClaimed INT UNSIGNED;
-- DECLARE _timeDiffTempClaimed INT UNSIGNED;
-- DECLARE _claimedByUserTempClaimed INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan) AND EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SELECT email,SUBSTRING_INDEX(email,'@',-1) into _email,_domain FROM users WHERE id_user = _id_user;
SELECT active,allow_promotions into _plan_active,_plan_allow_promotions FROM plans WHERE id_plan = _id_plan;

IF (_plan_active = 1)
THEN
-- #1 ----------------------- 
	IF (_plan_allow_promotions = 1)
	THEN
    -- #2 -----------------------        
        IF(_code <> '')
        THEN
        -- #3 ----------------------- 

			CALL SP_BIZ_PROMOTION_WITH_CODE(_code,_id_plan,_country_iso,_id_user,@return_code,@description,@id_promotion);

			IF(@return_code = 0)
		    THEN
		        IF(_id_promotion = @id_promotion)
                THEN
                    SELECT id_code into _id_code FROM promotions_codes_related WHERE code = _code;
					INSERT into promotions_used(id_promotion,id_code,id_plan,claimed_by_user,claimed_date,register_date) VALUES(_id_promotion,_id_code,_id_plan,_id_user,now(),now());
					SET p_last_id = last_insert_id();
					-- SELECT id,id_promotion,id_code,id_plan,claimed_by_user,claimed_date,register_date FROM promotions_used WHERE id = p_last_id;
                    SELECT 'okay' as description into @description;
				ELSE 
					SELECT -3 as return_code, 'promotion invalid' as description into @return_code,@description;
                END IF;
		    END IF;

        -- #3 -----------------------     
        ELSE    

            SELECT count(1) into @totalPromotions FROM promotions WHERE id_promotion in (SELECT id_promotion FROM promotions_plans_related WHERE id_plan = _id_plan) AND 
			code_required = 0 and active = 1 AND (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()));
				
                IF(@totalPromotions > 0)
				THEN
					CALL SP_BIZ_PROMOTION(_id_plan,_country_iso,_email,_domain,@return_code,@description,@id_promotion);
				ELSE
					SELECT -50 as return_code, 'no promotion available' as description into @return_code,@description;
				END IF;

			IF(@return_code = 0)
		    THEN
				INSERT into promotions_used(id_promotion,claimed_by_user,claimed_date,register_date) VALUES(_pid_promotion,_id_user,now(),now());
				SET p_last_id = last_insert_id();
                SELECT 'okay' as description into @description;
				-- SELECT id,id_promotion,id_code,id_plan,claimed_by_user,claimed_date,register_date FROM promotions_used WHERE id = p_last_id;
		    END IF;

		END IF;
    
	-- #2 ----------------------- 
    ELSE 
        SELECT -51 as return_code, 'plan does not allow promotions' as description into @return_code,@description;
    END IF;

	-- #1 -----------------------     
	ELSE    
		SELECT -52 as return_code, 'plan not active' as description into @return_code,@description;
	END IF;    

ELSE
    SELECT -2 as return_code, 'plan or user does not exists' as description into @return_code,@description;
END IF;

SELECT @return_code as return_code, @description as description;
        
COMMIT;

END;

