create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_BIZ_TRANSACTION_REFMB(IN _id_user bigint,
                                                                          IN _transaction_id varchar(255),
                                                                          IN _entity int(10), IN _reference int(10),
                                                                          IN _amount float(10, 2),
                                                                          IN _transaction_status varchar(45),
                                                                          IN _transaction_created_at datetime,
                                                                          IN _transaction_paid_at datetime)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
  
  INSERT into transactions_refmb(id_user,transaction_id,entity,reference,amount,transaction_status,transaction_created_at,transaction_paid_at,register_date)
  VALUES (_id_user,_transaction_id,_entity,_reference,_amount,_transaction_status,_transaction_created_at,_transaction_paid_at,now());
  SET p_last_id = last_insert_id();
  
  SELECT id_transaction,id_user,transaction_id,entity,reference,amount,transaction_status,transaction_created_at,transaction_paid_at,register_date
  FROM transactions_refmb WHERE id_transaction = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

