create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_BIZ_TRANSACTION_STRIPE(IN _id_user bigint,
                                                                           IN _transaction_id varchar(255),
                                                                           IN _object_id varchar(255),
                                                                           IN _customer_id varchar(255),
                                                                           IN _currency_iso varchar(255),
                                                                           IN _expires_at varchar(255),
                                                                           IN _amount float(10, 2),
                                                                           IN _transaction_status varchar(45),
                                                                           IN _transaction_created_at datetime,
                                                                           IN _transaction_paid_at datetime,
                                                                           IN _transaction_type varchar(155))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
  
  INSERT into transactions_stripe(id_user,transaction_id,object_id,customer_id,currency_iso,expires_at,amount,transaction_status,transaction_created_at,transaction_paid_at,transaction_type,register_date)
  VALUES(_id_user,_transaction_id,_object_id,_customer_id,_currency_iso,_expires_at,_amount,_transaction_status,_transaction_created_at,_transaction_paid_at,_transaction_type,now());
    SET p_last_id = last_insert_id();
  
  SELECT id_transaction,id_user,transaction_id,object_id,customer_id,currency_iso,amount,expires_at,transaction_status,transaction_created_at,transaction_paid_at,transaction_type,register_date
  FROM transactions_stripe WHERE id_transaction = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

