create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_BIZ_USER_TRANSACTION(IN _id_user bigint,
                                                                         IN _transaction_id varchar(255),
                                                                         IN _transaction_status varchar(155),
                                                                         IN _transaction_type varchar(155),
                                                                         IN _payment_service varchar(155),
                                                                         IN _transaction_created_at datetime,
                                                                         IN _transaction_paid_at datetime,
                                                                         IN _item_id int(10), IN _item_type int(10),
                                                                         IN _item_quantity int(10),
                                                                         IN _description varchar(255),
                                                                         IN _total_amount float(10, 2),
                                                                         IN _total_discount float(10, 2),
                                                                         IN _promotion_code varchar(255),
                                                                         IN _currency_iso char(3))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _active INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SET _active = 0;

IF(_item_type in (0,1,2,3,4))
THEN

		INSERT into user_transactions(id_user,transaction_id,transaction_status,transaction_type,payment_service,transaction_created_at,transaction_paid_at,item_id,item_type,item_quantity,description,total_amount,total_discount,promotion_code,currency_iso,register_date) 
		VALUES(_id_user,_transaction_id,_transaction_status,_transaction_type,_payment_service,_transaction_created_at,_transaction_paid_at,_item_id,_item_type,_item_quantity,_description,_total_amount,_total_discount,_promotion_code,_currency_iso,now());
		SET p_last_id = last_insert_id();
        
        IF(_item_type = 1)
        THEN
			IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _item_id)
            THEN
				IF(_transaction_status = 'completed')
                THEN
					SET _active = 1;
                END IF;
				INSERT into users_plans_related(id_user,id_plan,id_transaction,active,register_date) VALUES(_id_user,_item_id,p_last_id,_active,now());
            ELSE
				SELECT -3 as return_code;
            END IF;
        END IF;
        
		SELECT id_transaction,id_user,transaction_id,transaction_status,transaction_type,payment_service,transaction_created_at,transaction_paid_at,item_id,item_type,item_quantity,description,total_amount,total_discount,promotion_code,currency_iso,register_date
		FROM user_transactions WHERE id_transaction = p_last_id;
        
ELSE
    SELECT -3 as return_code;
END IF;        
        
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

