create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_AUDIENCES_GROUP_OPTIONS_RELATED(IN _id_group int(10),
                                                                                        IN _id_audience int(10),
                                                                                        IN _id_option int(10),
                                                                                        IN _option_value varchar(255))
BEGIN

 -- call SP_SET_OTT_AUDIENCES_GROUP_OPTIONS_RELATED(1,1,3,25);
 
 DECLARE p_last_id INT UNSIGNED;
 
 -- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	  SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

SET p_last_id = 0;

START TRANSACTION;

IF EXISTS (SELECT id_group FROM audiences_groups WHERE id_group = _id_group) AND EXISTS (SELECT id_audience FROM audiences WHERE id_audience = _id_audience) AND (SELECT id_option FROM audiences_options WHERE id_option = _id_option)
THEN

	IF NOT EXISTS (SELECT id_group FROM audiences_groups_options_related WHERE id_group = _id_group AND id_audience = _id_audience AND id_option = _id_option) 
	THEN
		INSERT into audiences_groups_options_related(id_group,id_audience,id_option,option_value,register_date) VALUES(_id_group,_id_audience,_id_option,_option_value,now());
	ELSE
		UPDATE audiences_groups_options_related SET option_value = _option_value WHERE id_group = _id_group AND id_audience = _id_audience AND id_option = _id_option;  
	END IF; 
	 
	 SELECT id_group,id_audience,id_option,option_value,register_date FROM audiences_groups_options_related WHERE id_group = _id_group AND id_audience = _id_audience AND id_option = _id_option;

ELSE
	SELECT -2 as return_code;
END IF;
	 
COMMIT;

END;

