create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_AVATAR(IN _id_group int(10), IN _id_avatar int(10),
                                                               IN _name varchar(192), IN _avatar varchar(192),
                                                               IN _active tinyint(1), IN _is_default tinyint(1),
                                                               IN _position int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF EXISTS(SELECT id_group FROM avatars_groups WHERE id_group = _id_group)
THEN

    IF(_id_avatar = 0 OR _id_avatar = -1)
    THEN
        INSERT into avatars(id_group,name,avatar,active,is_default,position,register_date) VALUES(_id_group,_name,_avatar,_active,_is_default,position,now());        
        SET p_last_id = last_insert_id();
    SELECT id_avatar,id_group,name,avatar,active,FN_GET_OTT_AVATARS_TOTAL_USERS(id_avatar) as total_selected,is_default,position,update_date, register_date FROM avatars WHERE id_avatar = p_last_id; 
    ELSE       
         IF EXISTS (SELECT id_avatar FROM avatars WHERE id_avatar = _id_avatar)
         THEN
            UPDATE avatars SET id_group = _id_group,name = _name,avatar = _avatar,active = _active,is_default = _is_default, position = _position,update_date = now() WHERE id_avatar = _id_avatar;
            SELECT id_avatar,id_group,name,avatar,active,FN_GET_OTT_AVATARS_TOTAL_USERS(id_avatar) as total_selected,is_default,position,update_date, register_date FROM avatars WHERE id_avatar = _id_avatar; 
         ELSE
            SELECT -2 as return_code;
         END IF;
    END IF;
    COMMIT;

ELSE
    SELECT -2 as return_code;
END IF;

END;

