create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_FREEBIE(IN _id_freebie int(10), IN _name varchar(255),
                                                                IN _name_stripped varchar(255), IN _begin_date datetime,
                                                                IN _end_date datetime,
                                                                IN _applied_to_all_periods tinyint(2),
                                                                IN _billing_period int(10),
                                                                IN _one_use_per_user tinyint(2), IN _active tinyint(2))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF (_id_freebie < 1)
THEN

	INSERT INTO freebies(name,name_stripped,begin_date,end_date,applied_to_all_periods,billing_period,one_use_per_user,active,register_date) 
	VALUES(_name,_name_stripped,_begin_date,_end_date,_applied_to_all_periods,_billing_period,_one_use_per_user,_active,now());
		SET p_last_id = last_insert_id();

	SELECT id_freebie,name,name_stripped,begin_date,end_date,applied_to_all_periods,billing_period,one_use_per_user,active,FN_GET_OTT_FREEBIES_TOTAL_PLANS(id_freebie) as total_plans,update_date,register_date FROM freebies WHERE id_freebie = p_last_id;

ELSE
	IF EXISTS(SELECT id_freebie FROM freebies WHERE id_freebie = _id_freebie)
	THEN
		
		UPDATE freebies SET name = _name,name_stripped = _name_stripped,begin_date = _begin_date,end_date = _end_date,applied_to_all_periods = _applied_to_all_periods,billing_period = _billing_period,one_use_per_user = _one_use_per_user,active = _active,update_date = now() WHERE id_freebie = _id_freebie;
		SELECT id_freebie,name,name_stripped,begin_date,end_date,applied_to_all_periods,billing_period,one_use_per_user,active,FN_GET_OTT_FREEBIES_TOTAL_PLANS(id_freebie) as total_plans,update_date,register_date FROM freebies WHERE id_freebie = _id_freebie;

	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

