create
    definer = skoiypp@`%` procedure SP_SET_OTT_LEADERBOARDS(IN _id_leaderboard int(10), IN _name varchar(255),
                                                            IN _name_stripped varchar(255), IN _allow_teams tinyint(1),
                                                            IN _allow_friends tinyint(1),
                                                            IN _allow_optimize_results tinyint(1),
                                                            IN _max_users_per_team int(10),
                                                            IN _total_teams_per_user int(10),
                                                            IN _max_friends_per_user int(10),
                                                            IN _max_optimization_attempts int(10),
                                                            IN _active tinyint(1))
BEGIN



DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;
DECLARE _leaderboard_token VARCHAR(192);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_leaderboard < 1)
THEN

SELECT SUBSTRING(MD5(RAND()) from 1 for 15) into _leaderboard_token;
WHILE NOT EXISTS(SELECT count(1) FROM leaderboards WHERE leaderboard_token = _leaderboard_token)
DO
	SELECT SUBSTRING(MD5(RAND()) from 1 for 15) into _leaderboard_token;
END WHILE;

	INSERT INTO leaderboards(name,name_stripped,leaderboard_token,allow_teams,allow_friends,allow_optimize_results,max_users_per_team,total_teams_per_user,max_friends_per_user,max_optimization_attempts,active,register_date) 
	VALUES(_name,_name_stripped,_leaderboard_token,_allow_teams,_allow_friends,_allow_optimize_results,_max_users_per_team,_total_teams_per_user,_max_friends_per_user,_max_optimization_attempts,_active,now());
		SET p_last_id = last_insert_id();

	SELECT id_leaderboard,name,name_stripped,leaderboard_token,allow_teams,allow_friends,allow_optimize_results,max_users_per_team,total_teams_per_user,max_friends_per_user,max_optimization_attempts,active,update_date,register_date FROM leaderboards WHERE id_leaderboard = p_last_id;

ELSE
	IF EXISTS(SELECT id_leaderboard FROM leaderboards WHERE id_leaderboard = _id_leaderboard)
	THEN
		
		UPDATE leaderboards SET name = _name,name_stripped = _name_stripped,allow_teams = _allow_teams,allow_friends = _allow_friends,allow_optimize_results = _allow_optimize_results,max_users_per_team = _max_users_per_team,total_teams_per_user = _total_teams_per_user,max_friends_per_user = _max_friends_per_user,max_optimization_attempts = _max_optimization_attempts,active = _active,update_date = now() WHERE id_leaderboard = _id_leaderboard;
	SELECT id_leaderboard,name,name_stripped,leaderboard_token,allow_teams,allow_friends,allow_optimize_results,max_users_per_team,total_teams_per_user,max_friends_per_user,max_optimization_attempts,active,update_date,register_date FROM leaderboards WHERE id_leaderboard = _id_leaderboard;

	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

