create
    definer = skoiypp@`%` procedure SP_SET_OTT_LEADERBOARDS_USERS_AVATARS(IN _id_avatar int(10),
                                                                          IN _id_leaderboard int(10),
                                                                          IN _name varchar(255), IN _id_asset int(10),
                                                                          IN _fname varchar(255),
                                                                          IN _avatar varchar(255),
                                                                          IN _active tinyint(1))
BEGIN

-- CALL SP_SET_OTT_LEADERBOARDS_USERS_AVATARS(1,1,'na',1,'file','avat',1)

DECLARE p_last_id INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF (_id_avatar < 1)
THEN

	INSERT INTO leaderboards_users_avatars(id_leaderboard,name,id_asset,filename,avatar,active,register_date) 
	VALUES(_id_leaderboard,_name,_id_asset,_fname,_avatar,_active,now());
		SET p_last_id = last_insert_id();

	SELECT id_avatar,id_leaderboard,name,id_asset,filename,avatar,active,update_date,register_date FROM leaderboards_users_avatars WHERE id_leaderboard = _id_leaderboard AND id_avatar = p_last_id;

ELSE
	IF EXISTS(SELECT id_leaderboard FROM leaderboards_users_avatars WHERE id_leaderboard = _id_leaderboard AND id_avatar = _id_avatar) 
	THEN
		UPDATE leaderboards_users_avatars SET name = _name,active = _active,update_date = now() WHERE id_leaderboard = _id_leaderboard AND id_avatar = _id_avatar;
		SELECT id_avatar,id_leaderboard,name,id_asset,filename,avatar,active,update_date,register_date FROM leaderboards_users_avatars WHERE id_leaderboard = _id_leaderboard AND id_avatar = _id_avatar;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

