create
    definer = skoiypp@`%` procedure SP_SET_OTT_PLAN_CLONE(IN _id_plan int)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM plans WHERE id_plan = _id_plan)
THEN

		INSERT INTO plans(plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
	trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
	unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,register_date) 
		SELECT plan_type,CONCAT('Copy of ',management_name),name_stripped,billing_type,billing_cycle,first_bill_date,
	trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
	unlimited_access,accept_pay_more,accept_pay_cycle,0,allow_promotions,now() FROM plans WHERE id_plan = _id_plan;
	SET p_last_id = last_insert_id();

	INSERT INTO plans_price_related(id_plan,price,trial_price,currency_iso,is_default,position,register_date)
		SELECT p_last_id,price,trial_price,currency_iso,is_default,position,now() FROM plans_price_related WHERE id_plan = _id_plan;

    INSERT INTO plans_l10n(id_plan,iso_language,name,description,details,action_name,action_target,register_date) 
         SELECT p_last_id,iso_language,name,description,details,action_name,action_target,now() FROM plans_l10n WHERE id_l10n in (SELECT id_l10n FROM plans_l10n WHERE id_plan = _id_plan);

	SELECT id_plan,plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
	trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
	unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,FN_GET_OTT_PLAN_TOTAL_USERS(id_plan) as total_users,update_date,register_date FROM plans WHERE id_plan = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

