create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PLAN_L10N(IN _id_l10n int(10), IN _id_plan int(10),
                                                                  IN _iso_language varchar(10), IN _name varchar(255),
                                                                  IN _description text, IN _details text,
                                                                  IN _action_name varchar(255),
                                                                  IN _action_target varchar(255))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan)
THEN
	IF(_id_l10n < 1)
	THEN
		IF NOT EXISTS (SELECT id_l10n FROM plans_l10n WHERE id_plan = _id_plan AND iso_language = _iso_language)
	    THEN
		INSERT INTO plans_l10n(id_l10n,id_plan,iso_language,name,description,details,action_name,action_target,register_date) VALUES(_id_l10n,_id_plan,_iso_language,_name,_description,_details,_action_name,_action_target,now());
		SET p_last_id = last_insert_id();
		SELECT id_l10n,id_plan,iso_language,name,description,details,action_name,action_target,register_date FROM plans_l10n WHERE id_l10n = p_last_id; 
		ELSE
	        SELECT -2 as return_code;
	    END IF;
	ELSE       
	     IF EXISTS (SELECT id_l10n FROM plans_l10n WHERE id_l10n = _id_l10n)
	     THEN
	        UPDATE plans_l10n SET name = _name,description = description, details = _details,action_name = _action_name,action_target = _action_target, update_date = now() WHERE id_l10n = _id_l10n AND id_plan = _id_plan;
			SELECT id_l10n,id_plan,iso_language,name,description,details,action_name,action_target,register_date FROM plans_l10n WHERE id_l10n = _id_l10n;
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

