create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PLAN_PRICES(IN _id int(10), IN _id_plan int(10),
                                                                    IN _price float(10, 2),
                                                                    IN _trial_price float(10, 2),
                                                                    IN _currency_iso char(3), IN _is_default tinyint(2),
                                                                    IN _position int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan)
THEN

IF(_id < 1)
THEN
    IF NOT EXISTS(SELECT id_plan FROM plans_price_related WHERE id_plan = _id_plan AND currency_iso = _currency_iso)
    THEN
        INSERT INTO plans_price_related(id_plan,currency_iso,price,trial_price,is_default,position,register_date) VALUES(_id_plan,_currency_iso,_price,_trial_price,_is_default,_position,now());
			SET p_last_id = last_insert_id();
			SELECT id,id_plan,currency_iso,price,trial_price,is_default,position,update_date,register_date FROM plans_price_related WHERE id = p_last_id;
    ELSE
         SELECT -3 as return_code;
    END IF;
ELSE 
	IF EXISTS (SELECT id FROM plans_price_related WHERE id = _id)
	THEN
		IF NOT EXISTS(SELECT id FROM plans_price_related WHERE currency_iso = _currency_iso AND id <> _id AND id_plan = _id_plan)
        THEN
			UPDATE plans_price_related SET currency_iso = _currency_iso,price = _price,trial_price = _trial_price,is_default = _is_default,position = _position, update_date = now() WHERE id = _id;
			SELECT id,id_plan,currency_iso,price,trial_price,is_default,position,update_date,register_date FROM plans_price_related WHERE id = _id; 
        ELSE
			SELECT -3 as return_code;
        END IF;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;    
    
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

