create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PLAN_SET(IN _id_plan_set int(10),
                                                                 IN _management_name varchar(255),
                                                                 IN _name_stripped varchar(255), IN _active tinyint(2),
                                                                 IN _domains text, IN _exclude tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF (_id_plan_set < 1)
THEN

	INSERT INTO plans_sets(management_name,name_stripped,active,domains,exclude,register_date) 
	VALUES(_management_name,_name_stripped,_active,_domains,_exclude,now());
		SET p_last_id = last_insert_id();

	SELECT id_plan_set,management_name,name_stripped,active,domains,exclude,FN_GET_OTT_PLAN_SET_TOTAL_PLANS(id_plan_set) as total_plans,update_date,register_date FROM plans_sets WHERE id_plan_set = p_last_id;

ELSE
	IF EXISTS(SELECT id_plan_set FROM plans_sets WHERE id_plan_set = _id_plan_set)
	THEN
		
        SELECT FN_SP_SET_PUBLISH_OTT_SYNC_UPDATE(20,_id_plan_set) into _empty;
		UPDATE plans_sets SET management_name = _management_name,name_stripped = _name_stripped,active = _active,domains = _domains,exclude =_exclude WHERE id_plan_set = _id_plan_set;
		SELECT id_plan_set,management_name,name_stripped,active,domains,exclude,FN_GET_OTT_PLAN_SET_TOTAL_PLANS(id_plan_set) as total_plans,update_date,register_date FROM plans_sets WHERE id_plan_set = _id_plan_set;

	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

