create
    definer = skoiypp@`%` procedure SP_SET_OTT_PLAN_SET_CLONE(IN _id_plan_set INT)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM plans_sets WHERE id_plan_set = _id_plan_set)
THEN

	INSERT INTO plans_sets(management_name,name_stripped,active,domains,exclude,register_date) 
		SELECT CONCAT('Copy of ',management_name),name_stripped,0,domains,exclude,now() FROM plans_sets WHERE id_plan_set = _id_plan_set;
	SET p_last_id = last_insert_id();

    INSERT into plans_sets_l10n(id_plan_set,iso_language,name,description,details,action_name,action_target,register_date) 
         SELECT p_last_id,iso_language,name,description,details,action_name,action_target,now() FROM plans_sets_l10n WHERE id_l10n in (SELECT id_l10n FROM plans_sets_l10n WHERE id_plan_set = _id_plan_set);

	INSERT INTO plans_sets_security_countries(id_plan_set,country_iso,exclude,register_date)
		SELECT p_last_id,country_iso,exclude,now() FROM plans_sets_security_countries WHERE id_plan_set = _id_plan_set;

	INSERT INTO plans_sets_plans_related(id_plan_set,id_plan,is_default,position,register_date)
		SELECT p_last_id,id_plan,is_default,position,now() FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set;

	SELECT id_plan_set,management_name,name_stripped,active,domains,exclude,FN_GET_OTT_PLAN_SET_TOTAL_PLANS(id_plan_set) as total_plans,update_date,register_date FROM plans_sets WHERE id_plan_set = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

