create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PROMOTION(IN _id_promotion int(10),
                                                                  IN _promotion_type tinyint(2),
                                                                  IN _percent_off float(10, 2),
                                                                  IN _price_off float(10, 2), IN _name varchar(255),
                                                                  IN _name_stripped varchar(255),
                                                                  IN _begin_date datetime, IN _end_date datetime,
                                                                  IN _applied_on_renewal tinyint(2),
                                                                  IN _applied_to_all_periods tinyint(2),
                                                                  IN _billing_period int(10), IN _active tinyint(2))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_promotion < 1)
THEN

	INSERT INTO promotions(promotion_type,percent_off,price_off,name,name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,active
,register_date) 
	VALUES(_promotion_type,_percent_off,_price_off,_name,_name_stripped,_begin_date,_end_date,_applied_on_renewal,_applied_to_all_periods,_billing_period,_active,now());
		SET p_last_id = last_insert_id();

	SELECT id_promotion,promotion_type,percent_off,price_off,name,name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,active,register_date FROM promotions WHERE id_promotion = p_last_id;

ELSE
	IF EXISTS(SELECT id_promotion FROM promotions WHERE id_promotion = _id_promotion)
	THEN
		UPDATE promotions SET promotion_type = _promotion_type,percent_off = _percent_off,price_off = _price_off,name = _name,name_stripped = _name_stripped,begin_date = _begin_date,end_date = _end_date,applied_on_renewal = _applied_on_renewal,applied_to_all_periods = _applied_to_all_periods,billing_period = _billing_period,active = _active WHERE id_promotion = _id_promotion;
		SELECT id_promotion,promotion_type,percent_off,price_off,name,name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,active,register_date FROM promotions WHERE id_promotion = _id_promotion;
	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

