create
    definer = skoiypp@`%` procedure SP_SET_OTT_PROMOTION_CLONE(IN _id_promotion INT)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM promotions WHERE id_promotion = _id_promotion)
THEN

	INSERT INTO promotions(promotion_type,percent_off,price_off,name,name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,code_required,active,register_date) 
		SELECT promotion_type,percent_off,price_off,CONCAT('Copy of ',name),name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,code_required,0,now() FROM promotions WHERE id_promotion = _id_promotion;
	SET p_last_id = last_insert_id();

	INSERT INTO promotions_security_countries(id_promotion,country_iso,exclude,register_date)
		SELECT p_last_id,country_iso,exclude,now() FROM promotions_security_countries WHERE id_promotion = _id_promotion;

	INSERT INTO promotions_plans_related(id_promotion,id_plan,position,register_date)
		SELECT p_last_id,id_plan,position,now() FROM promotions_plans_related WHERE id_promotion = _id_promotion;

	SELECT id_promotion,promotion_type,percent_off,price_off,name,name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,code_required,active,FN_GET_OTT_PROMOTION_TOTAL_PLANS(id_promotion) as total_plans,update_date,register_date FROM promotions WHERE id_promotion = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

