create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PROMOTION_CODES_RELATED(IN _id_code int(10),
                                                                                IN _id_promotion int(10),
                                                                                IN _code varchar(255),
                                                                                IN _quantity int(10),
                                                                                IN _unlimited tinyint(2),
                                                                                IN _active tinyint(2),
                                                                                IN _searchable tinyint(2),
                                                                                IN _random_code tinyint(2),
                                                                                IN _prefix varchar(255),
                                                                                IN _numbers int(10),
                                                                                IN _lowercase int(10),
                                                                                IN _uppercase int(10),
                                                                                IN _length int(10),
                                                                                IN _total_codes int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_promotion FROM promotions WHERE id_promotion = _id_promotion)
THEN

  IF(_id_code < 1)
  THEN
  
    IF(_random_code = 1)
    THEN
		SET @j = 0;
		WHILE(@j < _total_codes)
        DO
			SELECT FN_GENERATE_RANDOM_CODE(_prefix,_numbers,_lowercase,_uppercase,_length) into _code;
			WHILE NOT EXISTS(SELECT count(1) FROM promotions_codes_related WHERE code = _code)
			DO
				SELECT FN_GENERATE_RANDOM_CODE(_prefix,_numbers,_lowercase,_uppercase,_length) into _code;
			END WHILE;
			INSERT INTO promotions_codes_related(id_promotion,code,quantity,unlimited,active,searchable,register_date) VALUES(_id_promotion,_code,_quantity,_unlimited,_active,_searchable,now());
			SET p_last_id = last_insert_id();
            SET @j = @j+1;
        END WHILE;
		SELECT id_code,id_promotion,code,FN_GET_OTT_TOTAL_PROMOTION_USED(id_code) as total,quantity,unlimited,active,searchable,register_date FROM promotions_codes_related WHERE id_code = p_last_id;
    ELSE
		 IF NOT EXISTS(SELECT id_code FROM promotions_codes_related WHERE code = _code)
		 THEN
			 INSERT INTO promotions_codes_related(id_promotion,code,quantity,unlimited,active,searchable,register_date) VALUES(_id_promotion,_code,_quantity,_unlimited,_active,_searchable,now());
				SET p_last_id = last_insert_id();
			 SELECT id_code,id_promotion,code,FN_GET_OTT_TOTAL_PROMOTION_USED(id_code) as total,quantity,unlimited,active,searchable,register_date FROM promotions_codes_related WHERE id_code = p_last_id;
		 ELSE
			SELECT -3 as return_code;
		END IF;
	END IF;
     
  ELSE
		IF EXISTS(SELECT id_code FROM promotions_codes_related WHERE id_code = _id_code)
		 THEN
			 UPDATE promotions_codes_related SET quantity = _quantity, unlimited = _unlimited, active = _active, searchable = _searchable WHERE id_code = _id_code;
			 SELECT id_code,id_promotion,code,FN_GET_OTT_TOTAL_PROMOTION_USED(id_code) as total,quantity,unlimited,active,searchable,register_date FROM promotions_codes_related WHERE id_code = _id_code;
		ELSE
			SELECT -2 as return_code;
		END IF;
  END IF;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

