create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PROMOTION_SECURITY_COUNTRIES(IN _id_promotion int,
                                                                                     IN _country_iso char(2),
                                                                                     IN _exclude tinyint(1))
BEGIN

DECLARE p_last_id INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_promotion FROM promotions WHERE id_promotion = _id_promotion)
THEN
	INSERT into promotions_security_countries(id_promotion,country_iso,exclude,register_date) VALUES(_id_promotion,_country_iso,_exclude,now());
	SET p_last_id = last_insert_id();
    SELECT id_security,id_promotion,exclude, country_iso, register_date FROM promotions_security_countries WHERE id_security = p_last_id;
ELSE
	SELECT -2 as return_code;
END IF;

COMMIT;

END;

