create
    definer = skoiypp@`%` procedure SP_SET_OTT_SCANS(IN _id_scan int(10), IN _management_name varchar(255),
                                                     IN _scan_type tinyint(1), IN _start_date datetime,
                                                     IN _end_date datetime, IN _active tinyint(1))
BEGIN



DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;
DECLARE _scan_token VARCHAR(192);


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_scan < 1)
THEN

SELECT SUBSTRING(MD5(RAND()) from 1 for 15) into _scan_token;
WHILE NOT EXISTS(SELECT count(1) FROM scans WHERE scan_token = _scan_token)
DO
	SELECT SUBSTRING(MD5(RAND()) from 1 for 15) into _scan_token;
END WHILE;

	INSERT INTO scans(management_name,scan_token,scan_type,start_date,end_date,active,register_date) 
	VALUES(_management_name,_scan_token,_scan_type,_start_date,_end_date,_active,now());
		SET p_last_id = last_insert_id();

	SELECT id_scan,management_name,scan_token,scan_type,start_date,end_date,active,update_date,register_date FROM scans WHERE id_scan = p_last_id;

ELSE
	IF EXISTS(SELECT id_scan FROM scans WHERE id_scan = _id_scan)
	THEN
		
	UPDATE scans SET management_name = _management_name,scan_type = _scan_type,start_date = _start_date,end_date = _end_date,active = _active,update_date = now() WHERE id_scan = _id_scan;
  SELECT id_scan,management_name,scan_token,scan_type,start_date,end_date,active,update_date,register_date FROM scans WHERE id_scan = _id_scan;

	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

