create
    definer = skoiypp@`%` procedure SP_SET_OTT_SCANS_L10N(IN _id_l10n int(10), IN _id_scan int(10),
                                                          IN _iso_language varchar(10), IN _name varchar(255),
                                                          IN _name_stripped varchar(255), IN _description text,
                                                          IN _image varchar(255))
BEGIN



DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_scan FROM scans WHERE id_scan = _id_scan)
THEN
	IF(_id_l10n < 1)
	THEN
		IF NOT EXISTS (SELECT id_l10n FROM scans_l10n WHERE id_scan = _id_scan AND iso_language = _iso_language)
	    THEN
		INSERT INTO scans_l10n(id_l10n,id_scan,iso_language,name,name_stripped,description,image,register_date) VALUES(_id_l10n,_id_scan,_iso_language,_name,_name_stripped,_description,_image,now());
		SET p_last_id = last_insert_id();
		SELECT id_l10n,id_scan,iso_language,name,name_stripped,description,image,update_date,register_date FROM scans_l10n WHERE id_l10n = p_last_id; 
		ELSE
	        SELECT -2 as return_code;
	    END IF;
	ELSE       
	     IF EXISTS (SELECT id_l10n FROM scans_l10n WHERE id_l10n = _id_l10n)
	     THEN
	        UPDATE scans_l10n SET name = _name,name_stripped = _name_stripped,description = _description,image = _image, update_date = now() WHERE id_l10n = _id_l10n AND id_scan = _id_scan;
					SELECT id_l10n,id_scan,iso_language,name,name_stripped,description,image,update_date,register_date FROM scans_l10n WHERE id_l10n = _id_l10n;
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

