create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_SSO_AUTH_DEVICE_TOKEN(IN _device_code varchar(255),
                                                                          IN _access varchar(255),
                                                                          IN _refresh varchar(255))
BEGIN

DECLARE _state INT(10) UNSIGNED;
DECLARE _id BIGINT(20) UNSIGNED;
DECLARE _expired_in BIGINT(20) UNSIGNED;
DECLARE _register_date datetime;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SELECT id, expired_in,register_date,state into _id,_expired_in,_register_date,_state FROM oauth2_device WHERE device_code = _device_code;

-- state=1 user introduce the userCode
-- state=2 user granted access
-- state=3 user denied access

IF(_id = 0 OR _id is null)
THEN
	SELECT -2 as return_code; -- deviceCode or userCode not found
ELSE
	IF((SELECT DATE_ADD(_register_date, INTERVAL _expired_in SECOND)) <= now())
	THEN
		SELECT -3 as return_code; -- code expire
	ELSE
			
			IF(_state = 2)
			THEN
				UPDATE oauth2_device SET access = _access,refresh = _refresh WHERE device_code = _device_code AND state = 2; 
				SELECT access, refresh,id_user FROM oauth2_device WHERE device_code = _device_code AND state = 2;
			ELSE
					IF(_state = 3)
					THEN
						SELECT -6 as return_code; -- user denied access 
					END IF;
					IF(_state = 0 OR _state = 1)
					THEN
						SELECT -5 as return_code; -- authorization_pending error means the user isn’t finished logging in, but the code hasn’t yet expired either.
					END IF;
			END IF;
            
	END IF;
END IF;

COMMIT;

END;

