<?php namespace Skoiy\Ott;

use ArrayObject;
use Stage\Paginator;

class MyArrayObject extends ArrayObject
{
    public $count;
    public $paginator;

    public function toArray()
    {
        $temp = [];
        $iterator = $this->getIterator();
        while ($iterator->valid()) {
            $temp[] = $iterator->current()->toArray();

            $iterator->next();
        }
        return $temp;
    }

    public function setCount($count)
    {
        $this->count = $count;
    }

    public function count()
    {
        return $this->count;
    }

    public function setPaginator(Paginator $paginator)
    {
        $this->paginator = $paginator;
    }

    public function paginator()
    {
        return $this->paginator;
    }
}
