<?php namespace Skoiy\Ott\User\Metric;

class Query
{
    const NAME = 1;

    const BY_ID_USER = 100;
    const BY_EMAIL = 101;
    const BY_ID_PLAN = 102;
    const BY_PLAN_NAME = 103;
    const BY_VERIFIED = 104;

    const ORDER_BY_NAME_ASC = 11000;
    const ORDER_BY_NAME_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    const ORDER_BY_ID_PLAN_ASC = 11002;
    const ORDER_BY_ID_PLAN_DESC = 10002;

    /**
     * @var
     */
    public $by = 0;

    /**
     * @var
     */
    public $sndBy = 0;

    /**
     * @var
     */
    public $trdBy = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = 0;

    /**
     * @var
     */
    public $sndFilter = 0;

    /**
     * @var
     */
    public $trdFilter = 0;

    /**
     * @var
     */
    public $limitTrdA = 0;

    /**
     * @var
     *
     */
    public $limitTrdB = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }
}
