<?php namespace Skoiy\Ott\User;

use DateTime;
use Stage\Helper;

class TransactionQueryResponse
{
    /**
     * @var
     */
    private $id = -1;

    /**
     * @var
     */
    private $idTransaction;

    /**
     * @var
     */
    private $paymentService;

    /**
     * @var
     */
    private $description;

    /**
     * @var
     */
    private $itemId;

    /**
     * @var
     */
    private $itemType;

    /**
     * @var
     */
    private $transactionId;

    /**
     * @var
     */
    private $transactionStatus;

    /**
     * @var
     */
    private $transactionCreatedAt;

    /**
     * @var
     */
    private $transactionPaidAt;

    /**
     * @var
     */
    private $totalAmount;

    /**
     * @var
     */
    private $totalDiscount;

    /**
     * @var
     */
    private $promotionCode;

    /**
     * @var
     */
    private $currencyIso;

    /**
     * @var
     */
    private $entity;

    /**
     * @var
     */
    private $reference;

    /**
     * @var
     */
    private $amount;

    /**
     * @var
     */
    private $last4;

    /**
     * @var
     */
    private $updateDate;

    /**
     * @var
     */
    private $registerDate;

    /**
     * The model's attributes.
     *
     * @var array
     */
    protected $attributes = array('id', 'idTransaction', 'paymentService', 'description', 'itemId', 'itemType', 'transactionId', 'transactionStatus', 'transactionCreatedAt', 'transactionPaidAt', 'totalAmount', 'totalDiscount', 'promotionCode', 'currencyIso', 'entity', 'reference', 'amount', 'last4', 'updateDate', 'registerDate');

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = array('');

    /**
     * The attributes that should be visible in arrays.
     *
     * @var array
     */
    protected $visible = array();

    /**
     * The attributes that aren't mass assignable.
     *
     * @var array
     */
    protected $guarded = array('id');    // The attributes that cannot be setted on the model

    public function __construct()
    {
    }

    public function getId()
    {
        return $this->id;
    }

    /**
     * @return mixed
     */
    public function getIdTransaction()
    {
        return $this->idTransaction;
    }

    /**
     * @return mixed
     */
    public function getPaymentService()
    {
        return $this->paymentService;
    }

    /**
     * @return mixed
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * @return mixed
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * @return mixed
     */
    public function getItemType()
    {
        return $this->itemType;
    }

    /**
     * @return mixed
     */
    public function getTransactionId()
    {
        return $this->transactionId;
    }

    /**
     * @return mixed
     */
    public function getTransactionStatus()
    {
        return $this->transactionStatus;
    }

    /**
     * @return mixed
     */
    public function getTransactionCreatedAt()
    {
        return $this->transactionCreatedAt;
    }

    /**
     * @return mixed
     */
    public function getTransactionPaidAt()
    {
        return $this->transactionPaidAt;
    }

    /**
     * @return mixed
     */
    public function getTotalAmount()
    {
        return $this->totalAmount;
    }

    /**
     * @return mixed
     */
    public function getTotalDiscount()
    {
        return $this->totalDiscount;
    }

    /**
     * @return mixed
     */
    public function getPromotionCode()
    {
        return $this->promotionCode;
    }

    /**
     * @return mixed
     */
    public function getCurrencyIso()
    {
        return $this->currencyIso;
    }

    /**
     * @return mixed
     */
    public function getEntity()
    {
        return $this->entity;
    }

    /**
     * @return mixed
     */
    public function getReference()
    {
        return $this->reference;
    }

    /**
     * @return mixed
     */
    public function getAmount()
    {
        return $this->amount;
    }

    /**
     * @return mixed
     */
    public function getLast4()
    {
        return $this->last4;
    }

    /**
     * @return mixed
     */
    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    /**
     * @return mixed
     */
    public function getRegisterDate()
    {
        return $this->registerDate;
    }

    /**
     * @param mixed $idUser
     */
    public function setId($idUser)
    {
        $this->id = (int)$idUser;
    }

    /**
     * @param mixed $id
     */
    public function setIdTransaction($id)
    {
        $this->idTransaction = (int)$id;
    }


    /**
     * @param mixed $service
     */
    public function setPaymentService($service)
    {
        $this->paymentService = $service;
    }

    public function setDescription($desc)
    {
        $this->description = $desc;
    }

    /**
     * @param mixed $id
     */
    public function setItemId($id)
    {
        $this->itemId = $id;
    }

    /**
     * @param mixed $type
     */
    public function setItemType($type)
    {
        $this->itemType = $type;
    }

    /**
     * @param mixed $id
     */
    public function setTransactionId($id)
    {
        $this->transactionId = $id;
    }

    /**
     * @param mixed $status
     */
    public function setTransactionStatus($status)
    {
        $this->transactionStatus = $status;
    }

    /**
     * @param mixed $at
     */
    public function setTransactionCreatedAt($at)
    {
        $this->transactionCreatedAt = $at;
    }

    /**
     * @param mixed $at
     */
    public function setTransactionPaidAt($at)
    {
        $this->transactionPaidAt = $at;
    }

    /**
     * @param mixed $amount
     */
    public function setTotalAmount($amount)
    {
        $this->totalAmount = $amount;
    }

    /**
     * @param mixed $discount
     */
    public function setTotalDiscount($discount)
    {
        $this->totalDiscount = $discount;
    }

    /**
     * @param mixed $code
     */
    public function setPromotionCode($code)
    {
        $this->promotionCode = $code;
    }

    /**
     * @param mixed $iso
     */
    public function setCurrencyIso($iso)
    {
        $this->currencyIso = $iso;
    }

    /**
     * @param mixed $ent
     */
    public function setEntity($ent)
    {
        $this->entity = $ent;
    }

    /**
     * @param mixed $reference
     */
    public function setReference($reference)
    {
        $this->reference = $reference;
    }

    /**
     * @param mixed $amount
     */
    public function setAmount($amount)
    {
        $this->amount = $amount;
    }

    /**
     * @param mixed $amount
     */
    public function setLast4($last4)
    {
        $this->last4 = $last4;
    }

    /**
     * @param mixed $updateDate
     */
    public function setUpdateDate($updateDate)
    {
        $this->updateDate = $updateDate;
    }

    /**
     * @param mixed $registerDate
     */
    public function setRegisterDate($registerDate)
    {
        $this->registerDate = $registerDate;
    }

    /**
     * Convert the model instance to JSON.
     *
     * @param int $options
     * @return string
     */
    public function toJson()
    {
        return json_encode($this->toArray());
    }

    /**
     * Convert the model instance to an array.
     *
     * @return array
     */
    public function toArray()
    {
        $attributes = $this->attributesToArray();

        return $attributes;
    }

    /**
     * Convert the model's attributes to an array.
     *
     * @return array
     */
    public function attributesToArray()
    {
        $attributes = $this->getArrayableAttributes();
        $arr = array();

        foreach ($attributes as $attribute) {
            if ($attribute == "registerDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "updateDate" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else if ($attribute == "lastLogin" && $this->$attribute instanceof DateTime) {
                $arr[$attribute] = $this->$attribute->format(DATE_ATOM);
            } else {
                $arr[$attribute] = $attribute == "name" || $attribute == "nameStripped" || $attribute == "imageTitle" || $attribute == "imageAlterText" || $attribute == "plan" ? html_entity_decode($this->$attribute, ENT_COMPAT, 'UTF-8') : $this->$attribute;
            }
        }

        return $arr;
    }

    /**
     * Get an attribute array of all arrayable attributes.
     *
     * @return array
     */
    protected function getArrayableAttributes()
    {
        return $this->getArrayableItems($this->attributes);
    }

    /**
     * Get an attribute array of all arrayable values.
     *
     * @param array $values
     * @return array
     */
    protected function getArrayableItems(array $values)
    {
        if (count($this->visible) > 0) {
            return array_intersect_key($values, array_flip($this->visible));
        }

        return array_flip(array_diff_key(array_flip($values), array_flip($this->hidden)));
    }

    /**
     * createInstance
     *
     * @param $asset
     */
    public static function createInstance($asset)
    {
        $instance = new self();
        $instance->setId($asset['id_user']);
        $instance->setIdTransaction($asset['id_transaction']);
        $instance->setPaymentService($asset['payment_service']);
        $instance->setDescription(html_entity_decode($asset['description'], ENT_COMPAT, 'UTF-8'));
        $instance->setItemId($asset['item_id']);
        $instance->setItemType($asset['item_type']);
        $instance->setTransactionId($asset['transaction_id']);
        $instance->setTransactionStatus($asset['transaction_status']);
        $instance->setTransactionCreatedAt($asset['transaction_created_at']);
        $instance->setTransactionPaidAt($asset['transaction_paid_at']);
        $instance->setTotalAmount($asset['total_amount']);
        $instance->setTotalDiscount($asset['total_discount']);
        $instance->setPromotionCode($asset['promotion_code']);
        $instance->setCurrencyIso($asset['currency_iso']);
        $instance->setEntity($asset['entity']);
        $instance->setReference($asset['reference']);
        $instance->setAmount($asset['amount']);
        $instance->setLast4($asset['last4']);

        if (isset($asset['update_date']) && Helper::isValidDate($asset['update_date'], "Y-m-d H:i:s")) {
            $instance->setUpdateDate(new DateTime($asset['update_date']));
        }

        if (isset($asset['register_date']) && Helper::isValidDate($asset['register_date'], "Y-m-d H:i:s")) {
            $instance->setRegisterDate(new DateTime($asset['register_date']));
        }

        return $instance;
    }

    public function __toString()
    {
        return "My id is: {$this->getId()}\n";
    }

}