create
    definer = `youon-vrt14`@`%` procedure SP_GET_OTT_AUDIENCES()
BEGIN

    DECLARE _sqlcommand text;

-- call SP_GET_OTT_AUDIENCES()
    DECLARE no_more_rows INT DEFAULT FALSE;
    DECLARE num_rows INT DEFAULT 0;
    DECLARE c_name varchar(255);
    DECLARE c_sqlcommand text;
    DECLARE c_id_audience INT;

    DECLARE cursor_audience CURSOR FOR SELECT id_audience FROM audiences;

    DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

-- ###########################
    DECLARE exit handler for sqlexception
#         BEGIN
#             -- ERROR
#             SELECT -1 as return_code;
#             rollback;
#         END;
    -- ###########################

    -- cursor
    DROP TEMPORARY TABLE IF EXISTS a_tmp;
    CREATE TEMPORARY TABLE IF NOT EXISTS a_tmp SELECT 0 as id_audience, 0 as total;

    OPEN cursor_audience;
    SELECT FOUND_ROWS() into num_rows;

    read_loop: LOOP
        FETCH cursor_audience INTO c_id_audience;

        IF no_more_rows THEN
            LEAVE read_loop;
        END IF;

        -- do the work
        call SP_GET_OTT_AUDIENCES_COMMAND(c_id_audience);
        INSERT into a_tmp VALUES (c_id_audience,@atotal);

        -- end do the work

    END LOOP read_loop;

    CLOSE cursor_audience;
    -- end cursor

    SELECT a.id_audience,name,total,register_date FROM audiences a, a_tmp atp WHERE a.id_audience = atp.id_audience;

-- COMMIT;

END;

