create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_USER_PLANS(IN _id_user bigint, IN _field int(10),
                                                                   IN _field_snd int(10), IN _field_trd int(10),
                                                                   IN _query varchar(192), IN _filter varchar(192),
                                                                   IN _filter_snd varchar(192),
                                                                   IN _filter_trd varchar(192), IN _order_by int(10),
                                                                   IN _order int(10), IN _limit_a int(10),
                                                                   IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM users_plans_related WHERE id_user = _id_user;
END IF;

SET @_query = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @_id_user = _id_user;
SET @id_plan = _filter_snd;
SET @active = _filter_snd;


SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

START TRANSACTION;
  
  SET sqlcommand = "
  SELECT id,upr.id_plan,active,id_transaction,FN_GET_BIZ_PLAN(1,upr.id_plan,'') as name,register_date,
  FN_GET_BIZ_PLAN(2,upr.id_plan,register_date) as end_date,FN_GET_BIZ_PLAN(5,upr.id_plan,'') as plan_type,FN_GET_BIZ_PLAN(4,upr.id_plan,'') as plan_type_description FROM users_plans_related upr 
  WHERE upr.id_user = @_id_user ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");               
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan = @id_plan ) ");            
		END CASE;
	END IF;


CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_BIZ_PLAN(1,upr.id_plan,'') like @_query) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

		CASE
			WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY FN_GET_BIZ_PLAN(1,upr.id_plan,'') DESC ");
			WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY active DESC");            
			WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_plan DESC ");
			WHEN _order_by = 11004 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY end_date DESC ");
           
            
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY FN_GET_BIZ_PLAN(1,upr.id_plan,'') ASC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC ");  
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");            
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_plan ASC ");
			WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY end_date ASC ");
        
            
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC  ");
		END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
        
COMMIT;

END;

