create
    definer = skoiypp@`%` procedure SP_GET_ACCOUNT_TEAMS_COUNT(IN _id_account int(10), IN _field int(10),
                                                               IN _query varchar(192), IN _filter varchar(192))
BEGIN

DECLARE sqlcommand text;




DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_name = CONCAT("%",_query,"%");
SET @_id_team = _filter;
SET @_id_user = _filter;
SET @_id_account = _id_account;
SET @_num_x = _filter;

SET sqlcommand = "SELECT count(1) as total FROM teams WHERE id_account = @_id_account ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_team = @_id_team ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_team in (SELECT id_team FROM users_teams_related WHERE id_user = @_id_user) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;     
        
COMMIT;

END;

