create
    definer = skoiypp@`%` procedure SP_GET_BIZ_FREEBIES(IN _id_user bigint, IN _id_plan int(10), IN _country_iso char(2))
BEGIN

DECLARE _email VARCHAR(255);
DECLARE _domain VARCHAR(255);

DECLARE _plan_active INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code, '' as description;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan) AND EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SELECT email,SUBSTRING_INDEX(email,'@',-1) into _email,_domain FROM users WHERE id_user = _id_user;
SELECT active into _plan_active FROM plans WHERE id_plan = _id_plan;





IF (_plan_active = 1)
THEN
			
            SELECT count(1) into @totalFreebies FROM freebies WHERE id_freebie in (SELECT id_freebie FROM freebies_plans_related WHERE id_plan = _id_plan) AND 
			active = 1 AND (begin_date <= now() AND (date(end_date) = '0000-00-00' OR end_date >= now()));
				
                IF(@totalFreebies > 0)
				THEN
						CALL SP_BIZ_FREEBIE(_id_plan,_country_iso,_email,_domain,_id_user,@return_code,@description,@id_freebies,@freebie_id_codes);
				ELSE
					SELECT -50 as return_code, 'no freebie available' as description into @return_code,@description;
				END IF;
                
        END IF;

	IF(@return_code = 0)
    THEN
		SELECT 0 as return_code,f.id_freebie,l10n.name,l10n.description,l10n.details,l10n.action_name,l10n.action_target,iso_language, code
        FROM freebies f,freebies_l10n l10n, freebies_codes_related fcr WHERE f.id_freebie = l10n.id_freebie AND fcr.id_freebie = f.id_freebie 
        AND find_in_set(f.id_freebie,@id_freebies) AND find_in_set(fcr.id_code,@freebie_id_codes);
        
        INSERT into freebies_used(id_code,code,id_freebie,id_plan,claimed_by_user,claimed_date,register_date)
        SELECT id_code,code,id_freebie,_id_plan,_id_user,now(),now() FROM freebies_codes_related WHERE find_in_set(id_code,@freebie_id_codes);
        
    ELSE
		SELECT @return_code as return_code,@description as description;
    END IF;
        
ELSE
    SELECT -2 as return_code, 'plan or user does not exists' as description;
END IF;
        
COMMIT;

END;

