create
    definer = skoiypp@`%` procedure SP_GET_BIZ_PLAN_SETS(IN _domain varchar(255), IN _country_iso char(2),
                                                         IN _lang varchar(10))
BEGIN

	
	

DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_lang <> '')
THEN

	SELECT * FROM (
	SELECT psl10n.id_plan_set, psl10n.iso_language as plan_set_iso_language,psl10n.name as plan_set_name,psl10n.description as plan_set_description,psl10n.details as plan_set_details,psl10n.action_name as plan_set_action_name,psl10n.action_target as plan_set_action_target,
    pspr.id_plan,pspr.is_default as plan_default, pl10n.iso_language as plan_iso_language,pl10n.name as plan_name,pl10n.description as plan_description,pl10n.details as plan_details,pl10n.action_name as plan_action_name,pl10n.action_target as plan_action_target,
    FN_IS_NULL(ppr.price) as plan_price,FN_IS_NULL(ppr.trial_price) as plan_trial_price,FN_IS_NULL(ppr.currency_iso) as plan_currency_iso, FN_IS_NULL(ppr.is_default) as plan_price_default,pspr.position
    FROM plans_sets_l10n psl10n, plans_sets_plans_related pspr, plans_l10n pl10n, plans_sets ps, plans p left join plans_price_related ppr ON ppr.id_plan = p.id_plan
    WHERE p.id_plan = pspr.id_plan AND pspr.id_plan_set = psl10n.id_plan_set AND p.id_plan = pl10n.id_plan AND ps.id_plan_set = psl10n.id_plan_set
    AND p.active = 1 AND ps.active = 1
    AND FN_GET_OTT_PLAN_SET_ON_DOMAIN(psl10n.id_plan_set,_domain) = 1
    ) as tt WHERE plan_set_iso_language = _lang AND (FN_GET_OTT_PLAN_SET_ON_COUNTRY(id_plan_set,_country_iso) = 0 OR id_plan_set in (SELECT id_plan_set FROM plans_sets_security_countries WHERE country_iso = _country_iso AND exclude = 0))
    ORDER by id_plan_set,position;

ELSE

	SELECT * FROM (
	SELECT psl10n.id_plan_set, psl10n.iso_language as plan_set_iso_language,psl10n.name as plan_set_name,psl10n.description as plan_set_description,psl10n.details as plan_set_details,psl10n.action_name as plan_set_action_name,psl10n.action_target as plan_set_action_target,
    pspr.id_plan,pspr.is_default as plan_default, pl10n.iso_language as plan_iso_language,pl10n.name as plan_name,pl10n.description as plan_description,pl10n.details as plan_details,pl10n.action_name as plan_action_name,pl10n.action_target as plan_action_target,
    FN_IS_NULL(ppr.price) as plan_price,FN_IS_NULL(ppr.trial_price) as plan_trial_price,FN_IS_NULL(ppr.currency_iso) as plan_currency_iso, FN_IS_NULL(ppr.is_default) as plan_price_default,pspr.position
    FROM plans_sets_l10n psl10n, plans_sets_plans_related pspr, plans_l10n pl10n, plans_sets ps, plans p left join plans_price_related ppr ON ppr.id_plan = p.id_plan
    WHERE p.id_plan = pspr.id_plan AND pspr.id_plan_set = psl10n.id_plan_set AND p.id_plan = pl10n.id_plan AND ps.id_plan_set = psl10n.id_plan_set
    AND p.active = 1 AND ps.active = 1
    AND FN_GET_OTT_PLAN_SET_ON_DOMAIN(psl10n.id_plan_set,_domain) = 1
    ) as tt WHERE FN_GET_OTT_PLAN_SET_ON_COUNTRY(id_plan_set,_country_iso) = 0 OR id_plan_set in (SELECT id_plan_set FROM plans_sets_security_countries WHERE country_iso = _country_iso AND exclude = 0)
    ORDER by id_plan_set,position;

END IF;
        
COMMIT;

END;

