create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_BIZ_USER_BILLING_ACTIVITY(IN _id_user bigint, IN _limit_a int(10), IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_id_user = _id_user;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
  
  SET sqlcommand = "SELECT id_transaction,id_user,payment_service,description,item_id,item_type,transaction_id,transaction_status,transaction_created_at,transaction_paid_at,total_amount,total_discount,promotion_code,currency_iso,register_date, 
									(SELECT entity FROM transactions_refmb tmb WHERE tmb.transaction_id = transaction_id limit 0,1) as entity,
                                    (SELECT reference FROM transactions_refmb tmb WHERE tmb.transaction_id = transaction_id limit 0,1) as reference,
                                    (SELECT amount FROM transactions_refmb tmb WHERE tmb.transaction_id = transaction_id limit 0,1) as amount,
                                    FN_IS_NULL((SELECT last4 FROM transactions_stripe stripe WHERE stripe.transaction_id = transaction_id limit 0,1)) as last4
                                    FROM user_transactions WHERE id_user = @_id_user ORDER by register_date desc LIMIT ?,?"; 
  SET @sqlcommand = sqlcommand;

  PREPARE stmt FROM @sqlcommand;
  EXECUTE stmt USING @_limit_a,@_limit_b; 
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

