create
    definer = skoiypp@`%` procedure SP_GET_BIZ_USER_BILLING_ACTIVITY(IN _field int(10), IN _filter int(10),
                                                                     IN _id_user bigint, IN _limit_a int(10),
                                                                     IN _limit_b int(10))
BEGIN

	
	
	
DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

SET @_filter = _filter;
SET @_id_user = _id_user;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
  
  SET sqlcommand = "SELECT id_transaction,id_user,payment_service,description,FN_IS_NULL(FN_GET_BIZ_PLAN(1,item_id,transaction_paid_at)) as plan_name,item_id,item_type,transaction_id,transaction_status,transaction_created_at,transaction_paid_at,total_amount,total_discount,promotion_code,currency_iso,register_date, 
                  FN_IS_NULL((SELECT entity FROM transactions_refmb tmb WHERE tmb.transaction_id = ut.transaction_id limit 0,1)) as entity,
                                    FN_IS_NULL((SELECT reference FROM transactions_refmb tmb WHERE tmb.transaction_id = ut.transaction_id limit 0,1)) as reference,
                                    FN_IS_NULL((SELECT amount FROM transactions_refmb tmb WHERE tmb.transaction_id = ut.transaction_id limit 0,1)) as amount,
                                    FN_IS_NULL((SELECT last4 FROM transactions_stripe stripe WHERE stripe.transaction_id = ut.transaction_id limit 0,1)) as last4
                                    FROM user_transactions ut WHERE 1=1 "; 

  IF(_field = 1)
  THEN
  	  SET sqlcommand = CONCAT(sqlcommand, ' AND id_transaction = @_filter ');
  END IF;
                                   
  SET sqlcommand = CONCAT(sqlcommand, ' AND id_user = @_id_user ORDER by register_date desc LIMIT ?,?');

  SET @sqlcommand = sqlcommand;

  PREPARE stmt FROM @sqlcommand;
  EXECUTE stmt USING @_limit_a,@_limit_b; 
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

