create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_BIZ_USER_PLANS(IN _id_user bigint)
BEGIN

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
  
  SELECT distinct upr.id_plan,id_transaction,FN_GET_BIZ_PLAN(1,upr.id_plan,'') as name,register_date as begin_date,
  FN_GET_BIZ_PLAN(2,upr.id_plan,register_date) as end_date,FN_GET_BIZ_PLAN(5,upr.id_plan,'') as plan_type,FN_GET_BIZ_PLAN(4,upr.id_plan,'') as plan_type_description FROM users_plans_related upr 
  WHERE upr.id_user = _id_user AND upr.active = 1 ORDER by upr.update_date desc, upr.register_date desc; 

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

