create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_AVATARS(IN _field int(10), IN _query varchar(192),
                                                                IN _filter varchar(192), IN _order_by int(10),
                                                                IN _order int(10), IN _limit_a int(10),
                                                                IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM avatars;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _filter;
SET @_num_x = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_avatar,id_group,name,avatar,active,FN_GET_OTT_AVATARS_TOTAL_USERS(id_avatar) as total_selected,is_default,position,update_date, register_date FROM avatars a ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 1 AND name like @_name ");
WHEN _field = 3 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE active = 0 AND name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE id_group = @_id_group AND name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE FN_GET_OTT_AVATARS_TOTAL_USERS(id_avatar) = @_num_x ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

		CASE
			WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name DESC ");
			WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date DESC ");
			WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_group DESC ");
			WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_selected DESC ");

			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY name ASC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY register_date ASC "); 
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY id_group ASC ");
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY total_selected ASC ");


		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC  ");
		END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;    
   
COMMIT;

END;

