create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PLAN_SETS(IN _field int(10), IN _field_snd int(10),
                                                                  IN _field_trd int(10), IN _query varchar(192),
                                                                  IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                  IN _filter_trd varchar(192), IN _order_by int(10),
                                                                  IN _order int(10), IN _limit_a int(10),
                                                                  IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM plans_sets;
	SET @_limit_b = _limit_b;
END IF;

SET @id_plan_set = _filter_snd;
SET @active = _filter_snd;
SET @_name = CONCAT("%",_query,"%");
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

	SET sqlcommand = "SELECT id_plan_set,management_name,name_stripped,active,domains,exclude,FN_GET_OTT_PLAN_SET_TOTAL_PLANS(id_plan_set) as total_plans,update_date,register_date FROM plans_sets WHERE 1=1 ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan_set = @id_plan_set ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");                    

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;
    
	CASE
	WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND management_name like @_name ");
	ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1  ");
	END CASE;

	CASE

	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_plans ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");
	WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");  

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_plans DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active DESC");         
	WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name DESC");  
 

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
        
COMMIT;

END;

