create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PLAN_SET_PLANS(IN _id_plan_set int(10))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_plan_set FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set)
THEN
    
	SELECT p.id_plan,plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
		trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
		unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,FN_GET_OTT_PLAN_TOTAL_USERS(p.id_plan) as total_users,pspr.is_default,pspr.position,pspr.update_date,pspr.register_date 
        FROM plans p, plans_sets_plans_related pspr WHERE p.id_plan = pspr.id_plan AND id_plan_set = _id_plan_set ORDER by pspr.position;
    
ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

