create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PROMOTIONS(IN _field int(10), IN _field_snd int(10),
                                                                   IN _field_trd int(10), IN _query varchar(192),
                                                                   IN _filter varchar(192), IN _filter_snd varchar(192),
                                                                   IN _filter_trd varchar(192), IN _order_by int(10),
                                                                   IN _order int(10), IN _limit_a int(10),
                                                                   IN _limit_b int(10))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
	SELECT count(1) into _limit_b FROM promotions;
	SET @_limit_b = _limit_b;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @id_promotion = _filter_snd;
SET @active = _filter_snd;

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;


	SET sqlcommand = "SELECT id_promotion,promotion_type,percent_off,price_off,currency_iso,name,name_stripped,begin_date,end_date,applied_on_renewal,applied_to_all_periods,billing_period,code_required,active,FN_GET_OTT_PROMOTION_TOTAL_PLANS(id_promotion) as total_plans,update_date,register_date FROM promotions p WHERE 1=1 ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_promotion = @id_promotion ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");                    

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

	CASE
	WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
	WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
	WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active ASC");
	WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY promotion_type ASC");  
	WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_plans ASC");  

	WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name DESC");
	WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
	WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY active DESC");         
	WHEN _order_by = 11003 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY promotion_type DESC");  
	WHEN _order_by = 11004 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total_plans DESC");  

	ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY name ASC");
	END CASE;


	 SET sqlcommand = CONCAT(sqlcommand," LIMIT ?,?");

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt USING @_limit_a,@_limit_b; 
        
COMMIT;

END;

