create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_PROMOTION_CODES_COUNT(IN _field int(10), IN _field_snd int(10),
                                                                              IN _field_trd int(10),
                                                                              IN _query varchar(192),
                                                                              IN _filter varchar(192),
                                                                              IN _filter_snd varchar(192),
                                                                              IN _filter_trd varchar(192))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SET @id_promotion = _filter;
SET @id_code = _filter_snd;
SET @active = _filter_snd;
SET @unlimited = _filter_snd;
SET @pcode = CONCAT("%",_filter_snd,"%");

IF EXISTS(SELECT id_promotion FROM promotions WHERE id_promotion = _filter)
THEN

	SET sqlcommand = "SELECT count(1) as total FROM promotions_codes_related WHERE id_promotion = @id_promotion ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_code = @id_code ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");   
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (code like @pcode ) ");         
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (unlimited = @unlimited ) ");
            WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (searchable = @searchable ) "); 

		ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
		END CASE;
	END IF;

	SET @sqlcommand = sqlcommand;

	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt; 

ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

