create
    definer = skoiypp@`%` procedure SP_GET_OTT_PROMOTION_PLANS(IN _id_promotion int(10))
BEGIN


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS(SELECT id_promotion FROM promotions WHERE id_promotion = _id_promotion)
THEN
    
    	SELECT p.id_plan,plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
		trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
		unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,FN_GET_OTT_PLAN_TOTAL_USERS(p.id_plan) as total_users,ppr.position,ppr.update_date,ppr.register_date 
        FROM plans p, promotions_plans_related ppr WHERE p.id_plan = ppr.id_plan AND id_promotion = _id_promotion ORDER by ppr.position;
        
ELSE
	SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

