create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_USERS_COUNT(IN _field int(10), IN _field_snd int(10),
                                                                    IN _field_trd int(10), IN _query varchar(192),
                                                                    IN _filter varchar(192),
                                                                    IN _filter_snd varchar(192),
                                                                    IN _filter_trd varchar(192))
BEGIN

DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;


SET @_name = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @id_user = _filter_snd;
SET @email = _filter_snd;
SET @id_plan = _filter_snd;
SET @verified = _filter_snd;
SET @plan_stripped = _filter_snd;

SET sqlcommand = "SELECT count(1) as total FROM users u ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_user = @id_user ) ");
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (email = @email ) ");
			WHEN _field_snd = 102 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan = @id_plan ) ");  
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_OTT_PLAN(id_plan,2) = @plan_stripped ) ");              
			WHEN _field_snd = 104 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (verified = @verified ) ");              
		END CASE;
	END IF;

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " WHERE name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
   
COMMIT;

END;

