create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_USERS_PERFORMANCE(IN _field int(10), IN _field_snd int(10),
                                                                          IN _field_trd int(10), IN _query varchar(192),
                                                                          IN _filter varchar(192),
                                                                          IN _filter_snd varchar(192),
                                                                          IN _filter_trd varchar(192),
                                                                          IN _limit_trd_a varchar(255),
                                                                          IN _limit_trd_b varchar(255))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

-- #########################################################################################################
IF(_field = 1)
THEN

SET @gender = _filter_trd;
SET @verified = _filter_trd;
SET @days = _filter_trd;
SET @_year = _filter_trd;
SET @_limit_date_a = date(_limit_trd_a);
SET @_limit_date_b = date(_limit_trd_b);
    -- ------------------------------------------------------------------------------------
    IF(_field_snd = 0) -- ALL USERS
	THEN
		SET sqlcommand = "SELECT count(1) as total,'' as value FROM users WHERE 1=1 ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (verified = @verified ) ");                
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b) ");  
				WHEN _field_trd = 1003 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");           
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " ");
	END IF;
    -- ------------------------------------------------------------------------------------    
	-- ------------------------------------------------------------------------------------
	IF(_field_snd = 1) -- USERS BY DATE
	THEN
		SET sqlcommand = "SELECT count(1) as total, date(register_date) as value FROM users  WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b ) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");   
                WHEN _field_trd = 1003 THEN SET sqlcommand = "SELECT count(1) as total, date(verified_date) as value FROM users WHERE (verified = @verified) GROUP by date(verified_date)";
				WHEN _field_trd = 1004 THEN SET sqlcommand = "SELECT count(1) as total, date(verified_date) as value FROM users WHERE verified = 1 AND (date(verified_date) BETWEEN @_limit_date_a AND @_limit_date_b )  GROUP by date(verified_date) ";            
			END CASE;
		END IF;

        IF(_field_trd not in (1003,1004))
        THEN
       		SET sqlcommand = CONCAT(sqlcommand, " GROUP by date(register_date)"); 
        END IF;
        
	END IF;
    -- ------------------------------------------------------------------------------------
	-- ------------------------------------------------------------------------------------
	IF(_field_snd = 2) -- USERS BY HOUR
	THEN
		SET sqlcommand = "SELECT count(1) as total, hour(register_date) as value FROM users  WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b ) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");           
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by hour(register_date)");
	END IF;
    -- ------------------------------------------------------------------------------------
    -- ------------------------------------------------------------------------------------    
    IF(_field_snd = 3) -- USERS BY GENDER
	THEN
		SET sqlcommand = "SELECT count(1) as total, gender as value FROM users  WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) BETWEEN @_limit_date_a AND @_limit_date_b ) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (date(register_date) = (date(now()) - INTERVAL @days DAY)) ");           
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by gender");
	END IF;
    -- ------------------------------------------------------------------------------------  
	-- ------------------------------------------------------------------------------------
	IF(_field_snd = 4) -- USERS BY YEAR/MONTH
	THEN
		SET sqlcommand = "SELECT count(1) as total, month(register_date) as value FROM users WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1000 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (gender = @gender ) ");      
                WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND year(register_date) = @_year ");  
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " GROUP by month(register_date)");
	END IF;
    -- ------------------------------------------------------------------------------------
    
    SET @sqlcommand = sqlcommand;
   
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;    

END IF;
-- #########################################################################################################
-- #########################################################################################################
IF(_field = 2)
THEN

SET @gender = _filter_snd;
SET @days = _filter_trd;
SET @_limit_date_a = date(_limit_trd_a);
SET @_limit_date_b = date(_limit_trd_b);
SET @_limit_datetime_a = _limit_trd_a;
SET @_limit_datetime_b = _limit_trd_b;

    -- ------------------------------------------------------------------------------------ 
    IF(_field_snd = 0) -- ACTIVE USERS
	THEN
		SET sqlcommand = "SELECT count(1) as total, '' value FROM users WHERE 1=1  ";

		IF (_field_trd > 0)
		THEN
			CASE
				WHEN _field_trd = 1001 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) = (date(now()) - INTERVAL @days DAY) GROUP BY id) as tt1) ");  
				WHEN _field_trd = 1002 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) BETWEEN @_limit_date_a AND @_limit_date_b GROUP BY id) as tt2) ");  
				WHEN _field_trd = 1003 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE FN_GET_OTT_OAUTH_ACCESS_DATE(data) BETWEEN @_limit_datetime_a AND @_limit_datetime_b GROUP BY id) as tt2) ");  


				WHEN _field_trd = 1011 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND gender = @gender AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) = (date(now()) - INTERVAL @days DAY) GROUP BY id) as tt3) ");  
				WHEN _field_trd = 1012 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND gender = @gender AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) BETWEEN @_limit_date_a AND @_limit_date_b GROUP BY id) as tt4) ");  
				WHEN _field_trd = 1013 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND gender = @gender AND id_user in (SELECT id FROM (SELECT FN_GET_OTT_OAUTH_USER(data) as id FROM oauth2_token WHERE date(FN_GET_OTT_OAUTH_ACCESS_DATE(data)) BETWEEN @_limit_datetime_a AND @_limit_datetime_b GROUP BY id) as tt4) ");  

          
			END CASE;
		END IF;
		
		SET sqlcommand = CONCAT(sqlcommand, " ");
	END IF;

    SET @sqlcommand = sqlcommand;
   
	PREPARE stmt FROM @sqlcommand;
	EXECUTE stmt;    

END IF;

IF(_field not in (1,2))
THEN
	SELECT 0 as total, '' as value;
END IF;

        
COMMIT;

END;

