create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_OTT_USER_PLANS_COUNT(IN _id_user bigint, IN _field int(10),
                                                                         IN _field_snd int(10), IN _field_trd int(10),
                                                                         IN _query varchar(192),
                                                                         IN _filter varchar(192),
                                                                         IN _filter_snd varchar(192),
                                                                         IN _filter_trd varchar(192))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

SET @_query = CONCAT("%",_query,"%");
SET @_filter = CONCAT("%",_filter,"%");
SET @_cfilter = _filter;

SET @_id_user = _id_user;
SET @id_plan = _filter_snd;
SET @active = _filter_snd;

START TRANSACTION;
  
  SET sqlcommand = "
  SELECT count(1) as total FROM users_plans_related upr 
  WHERE upr.id_user = @_id_user ";

	IF (_field_snd > 0)
	THEN
		CASE
			WHEN _field_snd = 101 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (active = @active ) ");               
			WHEN _field_snd = 103 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_plan = @id_plan ) ");            
		END CASE;
	END IF;

CASE
WHEN _field = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (FN_GET_OTT_PULL_PLAN(1,upr.id_plan,'') like @_query) ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
   
        
COMMIT;

END;

