create
    definer = skoiypp@`%` procedure SP_GET_POSTS_DOSSIERS(IN _field int(10), IN _field_snd int(10),
                                                          IN _field_trd int(10), IN _query varchar(192),
                                                          IN _filter varchar(192), IN _filter_snd varchar(192),
                                                          IN _filter_trd varchar(192), IN _limit_sys_a bigint,
                                                          IN _limit_sys_b bigint, IN _iso_lang varchar(10),
                                                          IN _limit_a int(10), IN _limit_b int(10), IN _order int(10),
                                                          IN _order_by int(10))
BEGIN



DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM dossiers;
END IF;

SET @_name = CONCAT("%",_query,"%");
SET @_id_collection = _filter;
SET @_id_dossier = _filter;
SET @_id_post = _filter;
SET @_state = _filter;

SET @state = _filter_snd;
SET @id_dossier = _filter_snd;
SET @id_collection = _filter_snd;
SET @id_sticker = _filter_snd;
SET @id_tag = _filter_snd;
SET @_iso_lang = _iso_lang;

SET @_id_tag = _filter;
SET @_tags_group = REPLACE(_filter_trd,'%','');

SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

IF(_iso_lang = '')
THEN
    SET sqlcommand = "SELECT p.id_dossier, management_name, publish_date, begin_date, end_date, p.register_date, FN_GET_POSTS_ON_DOSSIERS_NUM(p.id_dossier) as total,FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(p.id_dossier) as on_collection, state,FN_GET_POSTS_L10N_ISO_GROUPED(2,p.id_dossier) as iso_grouped 
      FROM dossiers_l10n pln, dossiers p WHERE p.id_dossier = pln.id_dossier "; 
  ELSE
    SET sqlcommand = "SELECT p.id_dossier, management_name, publish_date, begin_date, end_date, p.register_date, FN_GET_POSTS_ON_DOSSIERS_NUM(p.id_dossier) as total,FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(p.id_dossier) as on_collection, state,FN_GET_POSTS_L10N_ISO_GROUPED(2,p.id_dossier) as iso_grouped 
    FROM dossiers_l10n pln, dossiers p WHERE p.id_dossier = pln.id_dossier AND iso_language = @_iso_lang "; 
  END IF;

  IF (_field_snd > 0)
  THEN
    CASE
      WHEN _field_snd = 100 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier = @id_dossier ) ");          
      WHEN _field_snd = 105 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = @id_collection) ) ");
      WHEN _field_snd = 107 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM dossiers_l10n_tags_related WHERE id_tag = @id_tag) ) ");
          
      WHEN _field_snd = 113 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n in (SELECT id_l10n FROM dossiers_l10n_tags_related)) ");            
      WHEN _field_snd = 115 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier in (SELECT id_dossier FROM dossiers_collections_related)) ");
      WHEN _field_snd = 117 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier in (SELECT id_dossier FROM dossiers_stickers_related WHERE id_sticker = @id_sticker) ) ");
      WHEN _field_snd = 118 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier in (SELECT id_dossier FROM dossiers_stickers_related)) ");
         
      WHEN _field_snd = 213 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_l10n not in (SELECT id_l10n FROM dossiers_l10n_tags_related)) ");            
      WHEN _field_snd = 215 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier not in (SELECT id_dossier FROM dossiers_collections_related)) ");
      WHEN _field_snd = 216 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (p.id_dossier not in (SELECT id_dossier FROM dossiers_stickers_related)) ");

      WHEN _field_snd = 116 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (state = @state ) ");

    ELSE SET sqlcommand = CONCAT(sqlcommand, " AND 1=1 ");
    END CASE;
  END IF;

  IF (_field_trd = 1000)
  THEN
    SET sqlcommand =  CONCAT(sqlcommand, " AND id_l10n in (SELECT id_l10n FROM dossiers_l10n_tags_related WHERE FIND_IN_SET(id_tag,@_tags_group) ) ");
  END IF;    

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND management_name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND state = @_state AND management_name like @_name ");
WHEN _field = 4 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(id_dossier) = 1 AND management_name like @_name ");
WHEN _field = 5 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND FN_GET_POSTS_IS_DOSSIERS_ON_COLLECTION(id_dossier) = 0 AND management_name like @_name ");
WHEN _field = 6 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND p.id_dossier in (SELECT id_dossier FROM dossiers_collections_related WHERE id_collection = @_id_collection) ");
WHEN _field = 7 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND p.id_dossier in (SELECT id_dossier FROM posts_dossiers_related WHERE id_post = @_id_post) ");

WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND p.id_dossier = @_id_dossier ");
WHEN _field = 17 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND (id_dossier in (SELECT id_dossier FROM dossiers_l10n WHERE id_l10n in (SELECT id_l10n FROM dossiers_l10n_tags_related WHERE id_tag = @_id_tag) )) ");

ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " GROUP BY p.id_dossier ");

CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY p.register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY p.register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY total DESC");

ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY management_name ASC");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;  
    
COMMIT;

END;

