create
    definer = skoiypp@`%` procedure SP_GET_POSTS_L10N_BODY_GROUPS(IN _id_l10n int(10), IN _field int(10),
                                                                  IN _query varchar(192), IN _filter varchar(192),
                                                                  IN _limit_a int(10), IN _limit_b int(10),
                                                                  IN _order int(10), IN _order_by int(10))
BEGIN




DECLARE sqlcommand text;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF(_limit_b = -1)
THEN
  SELECT count(1) into _limit_b FROM posts_l10n_body_groups WHERE id_l10n = _id_l10n;
END IF;

SET @_id_l10n = _id_l10n;
SET @_title = CONCAT("%",_query,"%");
SET @_id_group = _filter;
SET @_limit_a = _limit_a;
SET @_limit_b = _limit_b;

SET sqlcommand = "SELECT id_group,id_l10n,(SELECT id_post FROM posts_l10n pl WHERE pl.id_l10n = psg.id_l10n) as id_post,title,publish_date,draft,restricted,settings,token,register_date FROM posts_l10n_body_groups psg WHERE id_l10n = @_id_l10n ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND title like @_title ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_group = @_id_group ");
WHEN _field = 11 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND id_group like @_id_group AND title like @_title ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;


CASE
WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title ASC");
WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date ASC");
WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date ASC");

WHEN _order_by = 11000 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY title DESC");
WHEN _order_by = 11001 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY register_date DESC");
WHEN _order_by = 11002 AND _order = 0 THEN SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date DESC");


ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY publish_date desc");
END CASE;

SET sqlcommand = CONCAT(sqlcommand, " LIMIT ?,?");
SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt USING @_limit_a,@_limit_b;   


COMMIT; 

END;

