create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_SSO_AUTH_CHECK_CODE(IN _check_type tinyint(1),
                                                                        IN _device_code varchar(255),
                                                                        IN _user_code varchar(255), IN _id_user bigint)
BEGIN

DECLARE _state INT(10) UNSIGNED;
DECLARE _id BIGINT(20) UNSIGNED;
DECLARE _expired_in BIGINT(20) UNSIGNED;
DECLARE _register_date datetime;
DECLARE _idUser bigint(20);

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

SET _id = 0;
SET _expired_in = 0;
SET _idUser = 0;

IF(_check_type = 2)
THEN
SELECT id, expired_in,register_date,state,id_user into _id,_expired_in,_register_date,_state,_idUser FROM oauth2_device WHERE user_code = _user_code;
END IF;
IF(_check_type = 3)
THEN
SELECT id, expired_in,register_date,state,id_user into _id,_expired_in,_register_date,_state,_idUser FROM oauth2_device WHERE device_code = _device_code;
END IF;

-- state=1 user introduce the userCode
-- state=2 user granted access
-- state=3 user denied access

IF(_id = 0 OR _id is null)
THEN
	SELECT -2 as return_code,_idUser as id_user; -- deviceCode or userCode not found
ELSE
	IF((SELECT DATE_ADD(_register_date, INTERVAL _expired_in SECOND)) <= now())
	THEN
		SELECT -3 as return_code,_idUser as id_user; -- code expire
	ELSE
			
            -- FLOW BY DEVICE-CODE
            IF(_check_type = 3) -- validate if for deviceCode the user already insert the userCode
			THEN
				IF(_state = 2)
                THEN
					SELECT 0 as return_code,_idUser as id_user; -- user granted access
                ELSE
						IF(_state = 3)
						THEN
							SELECT -6 as return_code,_idUser as id_user; -- user denied access 
                        END IF;
                        IF(_state = 0 OR _state = 1)
						THEN
							SELECT -5 as return_code,_idUser as id_user; -- authorization_pending error means the user isn’t finished logging in, but the code hasn’t yet expired either.
                        END IF;
                END IF;
			END IF;
            
            -- FLOW BY USER-CODE
			IF(_check_type = 2)
			THEN
				IF(_state = 0) -- code exist and was not used -> associate to user
                THEN
					UPDATE oauth2_device SET  id_user = _id_user,state = 1 WHERE user_code = _user_code;
                    SELECT 0 as return_code,_idUser as id_user;
                ELSE
					SELECT -4 as return_code,_idUser as id_user; -- already used
                END IF;
			END IF;
            
	END IF;
END IF;

COMMIT;

END;

