create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_GET_SSO_AVATARS(IN _field int(10), IN _query varchar(192),
                                                                IN _filter varchar(192), IN _order_by int(10),
                                                                IN _order int(10))
BEGIN

DECLARE sqlcommand text;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;
-- a.position,ag.position as group_position

SET @_name = CONCAT("%",_query,"%");
SET @_id_group = _filter;

SET sqlcommand = "SELECT id_avatar,a.id_group,ag.name as group_name,a.name,avatar,a.position,ag.position as group_position, a.register_date FROM avatars a, avatars_groups ag WHERE a.id_group = ag.id_group AND active = 1 AND 1=1 ";

CASE
WHEN _field = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND a.name like @_name ");
WHEN _field = 2 THEN SET sqlcommand =  CONCAT(sqlcommand, " AND a.id_group = @_id_group AND a.name like @_name ");
ELSE SET sqlcommand = CONCAT(sqlcommand, "");
END CASE;

		CASE
			WHEN _order_by = 10000 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.name DESC ");
			WHEN _order_by = 11000 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.name ASC ");
			WHEN _order_by = 10001 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.register_date DESC ");
			WHEN _order_by = 11001 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.register_date ASC ");
			WHEN _order_by = 10002 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.id_group DESC ");
			WHEN _order_by = 11002 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.id_group ASC ");   
			WHEN _order_by = 10003 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.position DESC ");
			WHEN _order_by = 11003 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY a.position ASC ");   
			WHEN _order_by = 10004 AND _order = 0 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY ag.position DESC ");
			WHEN _order_by = 11004 AND _order = 1 THEN SET sqlcommand =  CONCAT(sqlcommand, " ORDER BY ag.position ASC ");               
		ELSE SET sqlcommand = CONCAT(sqlcommand, " ORDER BY a.name ASC  ");
		END CASE;

SET @sqlcommand = sqlcommand;
   
PREPARE stmt FROM @sqlcommand;
EXECUTE stmt;    
   
COMMIT;

END;

