create
    definer = skoiyott@`%` procedure SP_GET_SSO_USER_NEW(IN _id_user int(10))
BEGIN

    DECLARE _has INT(10);
    DECLARE _total_profiles INT(10);

    DECLARE _id_avatar INT(10);
    DECLARE _id_user_profile INT(10);
    DECLARE _avatar VARCHAR(255);
    DECLARE _profile_name VARCHAR(255);
    DECLARE _lang VARCHAR(10);



    DECLARE exit handler for sqlexception
        BEGIN
            
            SELECT -1 as return_code;
            rollback;
        END;


    START TRANSACTION;

    IF EXISTS(SELECT id_user FROM users WHERE id_user = _id_user)
    THEN

        SELECT count(1) into _total_profiles FROM users_profiles WHERE id_user = _id_user;

        SELECT id_user_profile,up.id_avatar,FN_SP_GET_OTT_AVATAR(id_avatar) as avatar,profile_name,lang
        into _id_user_profile,_id_avatar,_avatar,_profile_name,_lang
        FROM users_profiles up WHERE up.id_user = _id_user LIMIT 0,1;

        IF EXISTS(SELECT id_user FROM users WHERE id_user = _id_user AND password = '')
        THEN
            SET _has = 0;
        ELSE
            SET _has = 1;
        END IF;

        SELECT id_user,_has as has_password,_total_profiles as total_profiles,_avatar as avatar,FN_SP_GET_OTT_PLAN(id_plan,1) as plan,FN_SP_GET_OTT_PLAN(id_plan,2) as plan_stripped,full_name,short_name,email,gender,identification,tax_number,nationality,country_iso,city,membership_current_code,membership_serial_key,membership_level,membership_is_valid,membership_payment_date,membership_seats,membership_signup_date,active,verified,
               _id_user_profile as id_user_profile,_id_avatar as id_avatar,_profile_name as profile_name,_lang as lang,
               update_date, register_date FROM users WHERE id_user = _id_user;

    ELSE
        SELECT -2 as return_code;
    END IF;

    COMMIT;

END;

