create
    definer = skoiypp@`%` procedure SP_SET_ASSETS_TO_ALBUMS(IN _id_album int, IN _id_asset int, IN _position int)
BEGIN



DECLARE lastposition INT;
DECLARE _old_position INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_asset FROM assets WHERE id_asset = _id_asset) AND EXISTS (SELECT id_album FROM albums WHERE id_album = _id_album)
THEN

  SELECT count(1) into lastposition FROM assets_albums_related WHERE id_album = _id_album AND FN_GET_ASSETS_IS_DELETED(id_asset) = 0;
  SELECT position into _old_position FROM assets_albums_related WHERE id_asset = _id_asset AND id_album = _id_album;
  
  IF(_position = lastposition)
  THEN
    SET _position = _position+1;
  END IF;

    IF NOT EXISTS(SELECT id_asset FROM assets_albums_related WHERE id_asset = _id_asset AND id_album = _id_album)
    THEN
        
        IF(_position = 0)
        THEN
          SET _position = lastposition+1;
        END IF;

        INSERT INTO assets_albums_related(id_album,id_asset,position,register_date) VALUES(_id_album,_id_asset,_position,now());
        UPDATE assets SET state = '4' WHERE id_asset = _id_asset AND state NOT IN ('5');
        SELECT FN_SP_SET_PUBLISH_ASSETS_SYNC_UPDATE(16,_id_asset) into _empty;
        SELECT FN_SP_SET_PUBLISH_ASSETS_SYNC_UPDATE(160,_id_album) into _empty;        
		 SELECT 0 as return_code;
    ELSE
        
        UPDATE assets_albums_related SET position = _position, update_date = now() WHERE id_asset = _id_asset AND id_album = _id_album;
        
        IF(_position < _old_position)
        THEN
                SET @rownum=0;
                UPDATE assets_albums_related p, (SELECT @rownum:=@rownum+1 rownum, assets_albums_related.* FROM assets_albums_related WHERE id_album = _id_album ORDER BY position,update_date DESC) r 
                SET p.position = r.rownum
                WHERE (p.id_asset = r.id_asset AND p.id_album = _id_album) AND FN_GET_ASSETS_IS_DELETED(p.id_asset) = 0;
        ELSE
                SET @rownum=0;
                UPDATE assets_albums_related p, (SELECT @rownum:=@rownum+1 rownum, assets_albums_related.* FROM assets_albums_related WHERE id_album = _id_album ORDER BY position,update_date ASC) r 
                SET p.position = r.rownum
                WHERE (p.id_asset = r.id_asset AND p.id_album = _id_album) AND FN_GET_ASSETS_IS_DELETED(p.id_asset) = 0;
        END IF;
                    
            IF(_position < _old_position)
            THEN
                INSERT into assets_sync_updated(id_asset,action_type,register_date) SELECT id_asset,2,now() FROM assets 
                WHERE id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = _id_album AND position BETWEEN _position AND _old_position); 
            END IF;
            IF(_position > _old_position)
            THEN
                INSERT into assets_sync_updated(id_asset,action_type,register_date) SELECT id_asset,2,now() FROM assets 
                WHERE id_asset in (SELECT distinct id_asset FROM assets_albums_related WHERE id_album = _id_album AND position BETWEEN _old_position AND _position); 
            END IF;
		
        SELECT 0 as return_code;

    END IF;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

