create
    definer = skoiypp@`%` procedure SP_SET_BIZ_TRANSACTION_PAYPAL(IN _id_user bigint, IN _transaction_id varchar(255),
                                                                  IN _correlation_id varchar(255),
                                                                  IN _payer_id varchar(255), IN _amount float(10, 2),
                                                                  IN _transaction_status varchar(45),
                                                                  IN _transaction_created_at datetime,
                                                                  IN _transaction_paid_at datetime,
                                                                  IN _transaction_type varchar(155))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN
  
  INSERT into transactions_paypal(id_user,transaction_id,correlation_id,payer_id,amount,transaction_status,transaction_created_at,transaction_paid_at,transaction_type,register_date)
  VALUES(_id_user,_transaction_id,_correlation_id,_payer_id,_amount,_transaction_status,_transaction_created_at,_transaction_paid_at,_transaction_type,now());
    SET p_last_id = last_insert_id();
  
  SELECT id_transaction,id_user,transaction_id,correlation_id,payer_id,amount,transaction_status,transaction_created_at,transaction_paid_at,transaction_type,register_date
  FROM transactions_paypal WHERE id_transaction = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

