create
    definer = skoiypp@`%` procedure SP_SET_BIZ_USER_ORDER(IN _id_user bigint, IN _id_transaction bigint,
                                                          IN _id_item bigint, IN _item_type bigint,
                                                          IN _item_value varchar(255), IN _description varchar(255),
                                                          IN _available_at datetime, IN _expire_at datetime)
BEGIN
	
	
	

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user) AND EXISTS (SELECT id_transaction FROM user_wallet_transactions WHERE id_transaction = _id_transaction)
THEN

  	INSERT into user_orders(id_user,id_transaction,id_item,item_type,item_value,description,available_at,expire_at,register_date) VALUES(_id_user,_id_transaction,_id_item,_item_type,_item_value,_description,_available_at,_expire_at,now());

    SET p_last_id = last_insert_id();

    SELECT id_order,id_user,id_transaction,id_item,item_type,item_value,description,available_at,expire_at,register_date FROM user_orders WHERE id_order = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

