create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_BIZ_USER_WALLET(IN _id_user bigint, IN _name varchar(255),
                                                                    IN _currency_iso char(3), IN _token varchar(255),
                                                                    IN _active tinyint(2))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _id_wallet bigint(20) UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
THEN

SELECT id_wallet into _id_wallet FROM user_wallets WHERE token = _token;

IF EXISTS (SELECT id_wallet FROM user_wallets WHERE id_wallet = _id_wallet AND id_user = _id_user)
THEN
	UPDATE user_wallets SET active = _active, name = _name WHERE id_wallet = _id_wallet AND id_user = _id_user;
    SELECT id_wallet,id_user,name,currency_iso,token,active,(FN_GET_WALLET_SUM(id_wallet,1)-FN_GET_WALLET_SUM(id_wallet,2)) as balance,register_date FROM user_wallets WHERE id_wallet = _id_wallet;
ELSE

	IF NOT EXISTS(SELECT id_wallet FROM user_wallets WHERE currency_iso = _currency_iso AND id_user = _id_user)
	THEN

		SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
		WHILE NOT EXISTS(SELECT count(1) FROM user_wallets WHERE token = _token)
		DO
			SELECT SUBSTRING(MD5(RAND()) from 1 for 10) into _token;
		END WHILE;

		INSERT into user_wallets(id_user,name,currency_iso,token,active,register_date) 
		VALUES(_id_user,_name,_currency_iso,_token,_active,now());
		SET p_last_id = last_insert_id();
		SELECT id_wallet,id_user,name,currency_iso,token,active,(FN_GET_WALLET_SUM(id_wallet,1)-FN_GET_WALLET_SUM(id_wallet,2)) as balance,register_date FROM user_wallets WHERE id_wallet = p_last_id;
		
	ELSE
		SELECT -3 as return_code;
	END IF;

END IF;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

