create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_AVATARS_GROUP(IN _id_group int(10), IN _name varchar(255), IN _position int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_group FROM avatars_groups WHERE id_group = _id_group)
THEN
	UPDATE avatars_groups SET name = _name, position = _position,update_date = now() WHERE id_group = _id_group;
	SELECT id_group,name,FN_GET_OTT_NUM_AVATARS_ON_GROUP(id_group) as total_avatars,position, update_date, register_date FROM avatars_groups a WHERE id_group = _id_group;
ELSE
	INSERT into avatars_groups(name,position,register_date) VALUES (_name,_position,now());
	SET p_last_id = last_insert_id();
	SELECT id_group,name,FN_GET_OTT_NUM_AVATARS_ON_GROUP(id_group) as total_avatars,position, update_date, register_date FROM avatars_groups a WHERE id_group = p_last_id;
END IF;

COMMIT;

END;

