create
    definer = skoiypp@`%` procedure SP_SET_OTT_FREEBIE_CLONE(IN _id_freebie INT)
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF (SELECT count(1) FROM freebies WHERE id_freebie = _id_freebie)
THEN

	INSERT INTO freebies(name,name_stripped,begin_date,end_date,applied_to_all_periods,billing_period,one_use_per_user,active,register_date) 
		SELECT CONCAT('Copy of ',name),name_stripped,begin_date,end_date,applied_to_all_periods,billing_period,one_use_per_user,active,now() FROM freebies WHERE id_freebie = _id_freebie;
	SET p_last_id = last_insert_id();

    INSERT INTO freebies_l10n(id_freebie,iso_language,name,description,details,action_name,action_target,register_date) 
         SELECT p_last_id,iso_language,name,description,details,action_name,action_target,now() FROM freebies_l10n WHERE id_l10n in (SELECT id_l10n FROM freebies_l10n WHERE id_freebie = _id_freebie);

	INSERT INTO freebies_security_countries(id_freebie,country_iso,exclude,register_date)
		SELECT p_last_id,country_iso,exclude,now() FROM freebies_security_countries WHERE id_freebie = _id_freebie;

	INSERT INTO freebies_plans_related(id_freebie,id_plan,position,register_date)
		SELECT p_last_id,id_plan,position,now() FROM freebies_plans_related WHERE id_freebie = _id_freebie;

	SELECT id_freebie,name,name_stripped,begin_date,end_date,applied_to_all_periods,billing_period,one_use_per_user,active,FN_GET_OTT_FREEBIES_TOTAL_PLANS(id_freebie) as total_plans,update_date,register_date FROM freebies WHERE id_freebie = p_last_id;

ELSE
    SELECT -2 as return_code;
END IF;

COMMIT;

END;

