create
    definer = skoiypp@`%` procedure SP_SET_OTT_LEADERBOARD_L10N(IN _id_l10n INT(10), IN _id_leaderboard INT(10),
                                                                IN _iso_language VARCHAR(10),
                                                                IN _singular_unit VARCHAR(192),
                                                                IN _plural_units VARCHAR(192))
BEGIN

-- CALL SP_SET_OTT_LEADERBOARD_L10N(0,1,'en','point','points')

DECLARE p_last_id INT UNSIGNED;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

IF EXISTS (SELECT id_leaderboard FROM leaderboards WHERE id_leaderboard = _id_leaderboard)
THEN
	IF(_id_l10n < 1)
	THEN
		IF NOT EXISTS (SELECT id_l10n FROM leaderboards_l10n WHERE id_leaderboard = _id_leaderboard AND iso_language = _iso_language)
	    THEN
		INSERT INTO leaderboards_l10n(id_l10n,id_leaderboard,iso_language,singular_unit,plural_units,register_date) VALUES(_id_l10n,_id_leaderboard,_iso_language,_singular_unit,_plural_units,now());
		SET p_last_id = last_insert_id();
		SELECT id_l10n,id_leaderboard,iso_language,singular_unit,plural_units,update_date,register_date FROM leaderboards_l10n WHERE id_l10n = p_last_id; 
		ELSE
	        SELECT -2 as return_code;
	    END IF;
	ELSE       
	     IF EXISTS (SELECT id_l10n FROM leaderboards_l10n WHERE id_l10n = _id_l10n)
	     THEN
	        UPDATE leaderboards_l10n SET singular_unit = _singular_unit,plural_units = _plural_units, update_date = now() WHERE id_l10n = _id_l10n AND id_leaderboard = _id_leaderboard;
			SELECT id_l10n,id_leaderboard,iso_language,singular_unit,plural_units,update_date,register_date FROM leaderboards_l10n WHERE id_l10n = _id_l10n;
	     ELSE
	        SELECT -2 as return_code;
	     END IF;
	END IF;
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

