create
    definer = skoiypp@`%` procedure SP_SET_OTT_PLAN(IN _id_plan int(10), IN _plan_type tinyint(2),
                                                    IN _management_name varchar(255), IN _name_stripped varchar(255),
                                                    IN _billing_type int(10), IN _billing_cycle int(10),
                                                    IN _first_bill_date datetime, IN _trial_active tinyint(2),
                                                    IN _trial_type int(10), IN _trial_period int(10),
                                                    IN _trial_for_new_users tinyint(2), IN _time_active tinyint(2),
                                                    IN _time_type int(10), IN _time_period int(10),
                                                    IN _grace_active tinyint(2), IN _grace_type int(10),
                                                    IN _grace_period int(10), IN _unlimited_access tinyint(2),
                                                    IN _accept_pay_more tinyint(2), IN _accept_pay_cycle tinyint(2),
                                                    IN _active tinyint(2), IN _allow_promotions tinyint(2))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF (_id_plan < 1)
THEN

		INSERT INTO plans(plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
	trial_active,trial_type,trial_period,trial_for_new_users,
	time_active,time_type,time_period,grace_active,grace_type,grace_period,
	unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,register_date) 
		VALUES(_plan_type,_management_name,_name_stripped,_billing_type,_billing_cycle,_first_bill_date,
	_trial_active,_trial_type,_trial_period,_trial_for_new_users,_time_active,_time_type,_time_period,_grace_active,_grace_type,_grace_period,
	_unlimited_access,_accept_pay_more,_accept_pay_cycle,_active,_allow_promotions,now());
		SET p_last_id = last_insert_id();

	SELECT id_plan,plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
	trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
	unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,FN_GET_OTT_PLAN_TOTAL_USERS(id_plan) as total_users,update_date,register_date FROM plans WHERE id_plan = p_last_id;

ELSE
	IF EXISTS(SELECT id_plan FROM plans WHERE id_plan = _id_plan)
	THEN

		UPDATE plans SET plan_type = _plan_type,management_name = _management_name,name_stripped = _name_stripped,billing_type = _billing_type,billing_cycle = _billing_cycle,first_bill_date = _first_bill_date,
		trial_active = _trial_active,trial_type = _trial_type,trial_period = _trial_period,trial_for_new_users = _trial_for_new_users,time_active = _time_active,time_type = _time_type,time_period = _time_period,
		grace_active = _grace_active,grace_type = _grace_type,grace_period = _grace_period, unlimited_access = _unlimited_access,accept_pay_more = _accept_pay_more,accept_pay_cycle = _accept_pay_cycle,active = _active,allow_promotions = _allow_promotions WHERE id_plan = _id_plan;
	
		SELECT id_plan,plan_type,management_name,name_stripped,billing_type,billing_cycle,first_bill_date,
		trial_active,trial_type,trial_period,trial_for_new_users,time_active,time_type,time_period,grace_active,grace_type,grace_period,
		unlimited_access,accept_pay_more,accept_pay_cycle,active,allow_promotions,FN_GET_OTT_PLAN_TOTAL_USERS(id_plan) as total_users,update_date,register_date FROM plans WHERE id_plan = _id_plan;


	ELSE
		SELECT -2 as return_code;
	END IF;
END IF;
        
COMMIT;

END;

