create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PLAN_SET_CLONE_L10N(IN _id_plan_set int, IN _id_plan_set_clone int)
BEGIN

DECLARE no_more_rows INT DEFAULT FALSE;
DECLARE num_rows INT DEFAULT 0;
DECLARE c_id_l10n INT;
DECLARE c_iso_language VARCHAR(10);

DECLARE cursor_l10n CURSOR FOR SELECT id_l10n,iso_language FROM plans_sets_l10n WHERE id_plan_set = _id_plan_set;
DECLARE CONTINUE HANDLER FOR NOT FOUND SET no_more_rows = TRUE;

START TRANSACTION;

    
   
    OPEN cursor_l10n;
    IF(@result = -1)
        THEN
            SELECT -1 as return_code;
            ROLLBACK;
    END IF;
    SELECT FOUND_ROWS() into num_rows;
    
      read_loop: LOOP
        FETCH cursor_l10n INTO c_id_l10n,c_iso_language;
    
        IF no_more_rows THEN
          LEAVE read_loop;
        END IF;
      
	
                
    INSERT into plans_sets_l10n(id_plan_set,iso_language,name,description,details,action_name,action_target,register_date) 
         SELECT id_plan_set,iso_language,name,description,details,action_name,action_target,now() FROM plans_sets_l10n WHERE id_l10n = (SELECT id_l10n FROM plans_sets_l10n WHERE id_plan = _id_plan_set_clone AND iso_language = c_iso_language);

	
    
      END LOOP read_loop;

    CLOSE cursor_l10n;
    

COMMIT;

END;

