create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PLAN_SET_PLANS_RELATED(IN _id_plan_set int(10),
                                                                               IN _id_plan int(10),
                                                                               IN _is_default tinyint(2),
                                                                               IN _position int(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _empty INT;

DECLARE lastposition INT;
DECLARE currentposition INT;

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;


IF EXISTS (SELECT id_plan FROM plans WHERE id_plan = _id_plan) AND EXISTS (SELECT id_plan_set FROM plans_sets WHERE id_plan_set = _id_plan_set)
THEN

	SELECT position into currentposition FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set AND id_plan = _id_plan;
    SELECT count(1) into lastposition FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set;
	IF(_position = 0 OR _position = -1)
	  THEN
		SET _position = lastposition+1;
	END IF;

    IF NOT EXISTS(SELECT id_plan FROM plans_sets_plans_related WHERE id_plan = _id_plan AND id_plan_set = _id_plan_set)
    THEN
	
		INSERT INTO plans_sets_plans_related(id_plan,id_plan_set,is_default,position,update_date,register_date) VALUES(_id_plan,_id_plan_set,_is_default,_position,now(),now());
		 
		 SET @rownum=0;
		 UPDATE plans_sets_plans_related p, (SELECT @rownum:=@rownum+1 rownum, plans_sets_plans_related.* FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set ORDER BY position) r 
		 SET p.position = r.rownum WHERE (p.id_plan = r.id_plan);
     
    ELSE
         UPDATE plans_sets_plans_related SET is_default = _is_default, position = _position, update_date = now() WHERE id_plan = _id_plan AND id_plan_set = _id_plan_set; 
    END IF;
    
		 SELECT FN_SP_SET_PUBLISH_OTT_SYNC_UPDATE(20,_id_plan_set) into _empty;
         
		 IF(_position < currentposition)
		 THEN 
       		 SET @rownum=0;
			 UPDATE plans_sets_plans_related p, (SELECT @rownum:=@rownum+1 rownum, plans_sets_plans_related.* FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set ORDER BY position,update_date DESC) r 
			 SET p.position = r.rownum WHERE (p.id_plan = r.id_plan);  
         ELSE
			SET @rownum=0;
			 UPDATE plans_sets_plans_related p, (SELECT @rownum:=@rownum+1 rownum, plans_sets_plans_related.* FROM plans_sets_plans_related WHERE id_plan_set = _id_plan_set ORDER BY position,update_date ASC) r 
			 SET p.position = r.rownum WHERE (p.id_plan = r.id_plan);
         END IF;
         
		SELECT 0 as return_code;
ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

