create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_PROMOTION_CODES_RELATED(IN _id_code int(10),
                                                                                IN _id_promotion int(10),
                                                                                IN _code varchar(255),
                                                                                IN _quantity int(10),
                                                                                IN _unlimited tinyint(2),
                                                                                IN _active tinyint(2))
BEGIN

DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_promotion FROM promotions WHERE id_promotion = _id_promotion)
THEN

  IF(_id_code < 1)
  THEN
     
     IF NOT EXISTS(SELECT id_code FROM promotions_codes_related WHERE code = _code)
     THEN
		 INSERT INTO promotions_codes_related(id_promotion,code,quantity,unlimited,active,register_date) VALUES(_id_promotion,_code,_quantity,_unlimited,_active,now());
			SET p_last_id = last_insert_id();
		 SELECT id_code,id_promotion,code,FN_GET_OTT_TOTAL_PROMOTION_USED(id_code) as total,quantity,unlimited,active,register_date FROM promotions_codes_related WHERE id_code = p_last_id;
     ELSE
		SELECT -3 as return_code;
	END IF;
     
  ELSE
		IF EXISTS(SELECT id_code FROM promotions_codes_related WHERE id_code = _id_code)
		 THEN
			 UPDATE promotions_codes_related SET quantity = _quantity, unlimited = _unlimited, active = _active WHERE id_code = _id_code;
			 SELECT id_code,id_promotion,code,FN_GET_OTT_TOTAL_PROMOTION_USED(id_code) as total,quantity,unlimited,active,register_date FROM promotions_codes_related WHERE id_code = _id_code;
		ELSE
			SELECT -2 as return_code;
		END IF;
  END IF;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

