create
    definer = skoiypp@`%` procedure SP_SET_OTT_SCAN_CODES_RELATED(IN _id_code int(10), IN _id_scan int(10),
                                                                  IN _code varchar(255), IN _quantity int(10),
                                                                  IN _unlimited tinyint(2), IN _active tinyint(2),
                                                                  IN _max_scans_per_user int(10),
                                                                  IN _daily_limit_per_user int(10),
                                                                  IN _scan_interval_per_user int(10),
                                                                  IN _random_code tinyint(2), IN _prefix varchar(255),
                                                                  IN _numbers int(10), IN _lowercase int(10),
                                                                  IN _uppercase int(10), IN _length int(10),
                                                                  IN _total_codes int(10))
BEGIN



DECLARE p_last_id INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_scan FROM scans WHERE id_scan = _id_scan)
THEN

  IF(_id_code < 1)
  THEN
  
    IF(_random_code = 1)
    THEN
		SET @j = 0;
		WHILE(@j < _total_codes)
        DO
			SELECT FN_GENERATE_RANDOM_CODE(_prefix,_numbers,_lowercase,_uppercase,_length) into _code;
			WHILE NOT EXISTS(SELECT count(1) FROM scans_codes_related WHERE code = _code)
			DO
				SELECT FN_GENERATE_RANDOM_CODE(_prefix,_numbers,_lowercase,_uppercase,_length) into _code;
			END WHILE;
			INSERT INTO scans_codes_related(id_scan,code,quantity,unlimited,active,max_scans_per_user,daily_limit_per_user,scan_interval_per_user,register_date) VALUES(_id_scan,_code,_quantity,_unlimited,_active,_max_scans_per_user,_daily_limit_per_user,_scan_interval_per_user,now());
			SET p_last_id = last_insert_id();
            SET @j = @j+1;
        END WHILE;
		SELECT id_code,id_scan,code,FN_GET_OTT_TOTAL_SCAN_USED(id_code) as total,quantity,unlimited,active,max_scans_per_user,daily_limit_per_user,scan_interval_per_user,register_date FROM scans_codes_related WHERE id_code = p_last_id;
    ELSE
		 IF NOT EXISTS(SELECT id_code FROM scans_codes_related WHERE code = _code)
		 THEN
			 INSERT INTO scans_codes_related(id_scan,code,quantity,unlimited,active,max_scans_per_user,daily_limit_per_user,scan_interval_per_user,register_date) VALUES(_id_scan,_code,_quantity,_unlimited,_active,_max_scans_per_user,_daily_limit_per_user,_scan_interval_per_user,now());
				SET p_last_id = last_insert_id();
			 SELECT id_code,id_scan,code,FN_GET_OTT_TOTAL_SCAN_USED(id_code) as total,quantity,unlimited,active,max_scans_per_user,daily_limit_per_user,scan_interval_per_user,register_date FROM scans_codes_related WHERE id_code = p_last_id;
		 ELSE
			SELECT -3 as return_code;
		END IF;
	END IF;
     
  ELSE
		IF EXISTS(SELECT id_code FROM scans_codes_related WHERE id_code = _id_code)
		 THEN
			 UPDATE scans_codes_related SET quantity = _quantity, unlimited = _unlimited, active = _active, max_scans_per_user = _max_scans_per_user,daily_limit_per_user = _daily_limit_per_user,scan_interval_per_user = _scan_interval_per_user WHERE id_code = _id_code;
			 SELECT id_code,id_scan,code,FN_GET_OTT_TOTAL_SCAN_USED(id_code) as total,quantity,unlimited,active,max_scans_per_user,daily_limit_per_user,scan_interval_per_user,register_date FROM scans_codes_related WHERE id_code = _id_code;
		ELSE
			SELECT -2 as return_code;
		END IF;
  END IF;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

