create
    definer = `skoiyOTTFPB-pp`@`%` procedure SP_SET_OTT_USER(IN _id_user bigint, IN _name varchar(255),
                                                             IN _email varchar(255), IN _gender tinyint(2),
                                                             IN _birthdate date, IN _identification varchar(255),
                                                             IN _tax_number varchar(255), IN _nationality varchar(255),
                                                             IN _country_iso varchar(255), IN _address varchar(255),
                                                             IN _city varchar(255), IN _zipcode varchar(255),
                                                             IN _phone varchar(255), IN _active tinyint(2),
                                                             IN _verified tinyint(2))
BEGIN

DECLARE _total INT(10);
DECLARE _currentEmail INT(10);

-- ###########################
DECLARE exit handler for sqlexception
  BEGIN
    -- ERROR
	SELECT -1 as return_code;
    rollback;
  END;
-- ###########################

START TRANSACTION;

 	IF EXISTS(SELECT id_user FROM users WHERE id_user = _id_user)
 	THEN 

 		SELECT count(1) into _total FROM users WHERE id_user <> _id_user AND email = _email;
 		SELECT count(1) into _currentEmail FROM users WHERE id_user = _id_user; 		

 		UPDATE users SET name = _name,gender = _gender,birthdate = _birthdate,identification = _identification,tax_number = _tax_number,nationality = _nationality,country_iso = _country_iso,address = _address,city = _city,zipcode = _zipcode,phone = _phone,active = _active,verified = _verified, update_date = now()
 		WHERE id_user = _id_user;

 		IF(_currentEmail <> _email AND _email <> '')
 		THEN
	 		IF(_total = 0)
	 		THEN
	 			UPDATE users SET email = _email WHERE id_user = _id_user;
	 			SELECT id_user,id_plan,FN_GET_OTT_PLAN(id_plan,1) as plan,FN_GET_OTT_PLAN(id_plan,2) as plan_stripped,FN_GET_OTT_USER_TOTAL_PROFILES(id_user) as total_profiles,name,email,gender,birthdate,identification,tax_number,nationality,country_iso,address,city,zipcode,phone,active,verified,last_login,update_date, register_date,FN_GET_OTT_USER_LAST_ACCESS_DATE(id_user) as last_activity 
				FROM users u WHERE id_user = _id_user;
	 		ELSE
	 			SELECT -3 as return_code;
	 		END IF;
	 	ELSE
			SELECT id_user,id_plan,FN_GET_OTT_PLAN(id_plan,1) as plan,FN_GET_OTT_PLAN(id_plan,2) as plan_stripped,FN_GET_OTT_USER_TOTAL_PROFILES(id_user) as total_profiles,name,email,gender,birthdate,identification,tax_number,nationality,country_iso,address,city,zipcode,phone,active,verified,last_login,update_date, register_date,FN_GET_OTT_USER_LAST_ACCESS_DATE(id_user) as last_activity 
			FROM users u WHERE id_user = _id_user;	 		
	 	END IF;

 	ELSE
 		SELECT -2 as return_code;
 	END IF;
        
COMMIT;

END;

