create
    definer = skoiypp@`%` procedure SP_SET_SSO_LEADERBOARD_RESULT(IN _leaderboard_token varchar(192),
                                                                  IN _id_user bigint, IN _level_token varchar(192),
                                                                  IN _score int(10), IN _time decimal(10, 2))
BEGIN




DECLARE p_last_id INT UNSIGNED;
DECLARE _id_leaderboard INT UNSIGNED;
DECLARE _allow_optimize_results INT UNSIGNED;
DECLARE _max_optimization_attempts INT UNSIGNED;
DECLARE _id_level INT UNSIGNED;

DECLARE _totalAttempts INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_leaderboard FROM leaderboards WHERE leaderboard_token = _leaderboard_token)
THEN

	SELECT id_leaderboard,allow_optimize_results,max_optimization_attempts into _id_leaderboard,_allow_optimize_results,_max_optimization_attempts
	FROM leaderboards WHERE leaderboard_token = _leaderboard_token; 

	IF NOT EXISTS (SELECT id_level FROM leaderboards_levels WHERE level_token = _level_token)
	THEN
			INSERT into leaderboards_levels(id_leaderboard,level_token,register_date) VALUES(_id_leaderboard,_level_token,now());
			SET _id_level = last_insert_id();
	ELSE
			SELECT id_level into _id_level FROM leaderboards_levels WHERE level_token = _level_token;
	END IF;


	IF NOT EXISTS (SELECT id_result FROM leaderboards_results WHERE id_user = _id_user AND id_leaderboard = _id_leaderboard AND id_level = _id_level)
	THEN
			INSERT into leaderboards_results(id_leaderboard,id_user,id_level,score,time,attempts,register_date)
			VALUES(_id_leaderboard,_id_user,_id_level,_score,_time,1,now());
			SELECT 0 as return_code;
	ELSE

			IF(_allow_optimize_results = 1)
			THEN
					SELECT attempts into _totalAttempts FROM leaderboards_results WHERE id_user = _id_user AND id_leaderboard = _id_leaderboard AND id_level = _id_level;

					IF(_totalAttempts < _max_optimization_attempts)
					THEN
						INSERT into leaderboards_results(id_leaderboard,id_user,id_level,score,time,attempts,register_date)
						VALUES(_id_leaderboard,_id_user,_id_level,_score,_time,1,now()) 
						ON DUPLICATE KEY UPDATE score = GREATEST(score, VALUES(score)), time = LEAST(time, VALUES(time)), attempts = attempts + 1,update_date = now();
				    SELECT 0 as return_code;
					ELSE
						SELECT -20 as return_code;
					END IF;

			ELSE
						SELECT -30 as return_code;
			END IF;

END IF;

ELSE
    SELECT -2 as return_code;
END IF;
        
COMMIT;

END;

