create
    definer = skoiypp@`%` procedure SP_SET_SSO_USER_PROFILE_2(IN _id_user_profile bigint, IN _id_user bigint,
                                                              IN _id_avatar int(10), IN _profile_name varchar(192),
                                                              IN _profile_type tinyint(1), IN _lang varchar(192),
                                                              IN _lang_of_content varchar(192),
                                                              IN _autoplay_next_video tinyint(1),
                                                              IN _autoplay_previews tinyint(1),
                                                              IN _lock_active tinyint(1), IN _lock_pin varchar(10))
BEGIN

DECLARE p_last_id INT UNSIGNED;
DECLARE _total_default INT UNSIGNED;


DECLARE exit handler for sqlexception
  BEGIN
    
	SELECT -1 as return_code;
    rollback;
  END;


SET p_last_id = 0;

START TRANSACTION;

IF(_id_avatar = 0)
THEN
	SET _id_avatar = null;
END IF;

     IF EXISTS (SELECT id_user FROM users WHERE id_user = _id_user)
     THEN

		IF ((SELECT count(1) FROM avatars WHERE id_avatar = _id_avatar AND _id_avatar > 0) > 0) OR _id_avatar is null 
		THEN

		IF(_id_avatar is null)
		THEN
			SELECT count(1) into _total_default FROM avatars WHERE is_default = 1;
			IF(_total_default > 1)
			THEN
				SELECT id_avatar into _id_avatar FROM avatars WHERE is_default = 1 AND id_avatar not in (SELECT id_avatar FROM users_profiles WHERE id_user = _id_user) LIMIT 0,1;
			ELSE
				SELECT id_avatar into _id_avatar FROM avatars WHERE is_default = 1 LIMIT 0,1; 
			END IF;
		END IF;

			IF(_id_user_profile = 0 OR _id_user_profile = -1)
			THEN
            
				 IF NOT EXISTS (SELECT id_user_profile FROM users_profiles WHERE id_avatar = _id_avatar AND id_user = _id_user AND _id_avatar > 0)
				 THEN
					INSERT into users_profiles(id_user,id_avatar,profile_name,profile_type,lang,lang_of_content,autoplay_next_video,autoplay_previews,lock_active,lock_pin,register_date) VALUES(_id_user,_id_avatar,_profile_name,_profile_type,_lang,_lang_of_content,_autoplay_next_video,_autoplay_previews,_lock_active,_lock_pin,now());        
					SET p_last_id = last_insert_id();
					SELECT id_user_profile,id_user,id_avatar,profile_name,profile_type,lang,lang_of_content,autoplay_next_video,autoplay_previews,lock_active,lock_pin,update_date, register_date FROM users_profiles WHERE id_user_profile = p_last_id; 
				 ELSE
					SELECT -3 as return_code;
				 END IF;

			ELSE       
            
				 IF EXISTS (SELECT id_user_profile FROM users_profiles WHERE id_user_profile = _id_user_profile AND id_user = _id_user)
				 THEN
					UPDATE users_profiles SET id_avatar = _id_avatar,profile_name = _profile_name,lang = _lang,lang_of_content = _lang_of_content,autoplay_next_video = _autoplay_next_video,autoplay_previews = _autoplay_previews,lock_active = _lock_active,lock_pin = _lock_pin, update_date = now() WHERE id_user_profile = _id_user_profile;
					SELECT id_user_profile,id_user,id_avatar,profile_name,lang,lang_of_content,autoplay_next_video,autoplay_previews,lock_active,lock_pin,update_date, register_date FROM users_profiles WHERE id_user_profile = _id_user_profile AND id_user = _id_user; 
				 ELSE
					SELECT -2 as return_code;
				 END IF;
			END IF;
            
		ELSE
					SELECT -2 as return_code;
		END IF;  

ELSE
			SELECT -2 as return_code;
END IF;            

COMMIT;

END;

