create
    definer = skoiypp@`%` procedure SP_SET_VIDEO_CHANNELS_STICKER_RELATED(IN _id_sticker int(10),
                                                                          IN _id_channel int(10), IN _position int(10),
                                                                          IN _begin_date datetime,
                                                                          IN _end_date datetime, IN _color varchar(255))
BEGIN



DECLARE lastposition INT;
DECLARE currentposition INT;
DECLARE _empty INT;


DECLARE exit handler for sqlexception
  BEGIN
    
    SELECT -1 as return_code;
    rollback;
  END;


START TRANSACTION;

IF EXISTS (SELECT id_sticker FROM video_stickers WHERE id_sticker = _id_sticker) AND EXISTS (SELECT id_channel FROM channels WHERE id_channel = _id_channel)
THEN

	SELECT position into currentposition FROM channels_stickers_related WHERE id_sticker = _id_sticker AND id_channel = _id_channel;
    SELECT count(1) into lastposition FROM channels_stickers_related WHERE id_sticker = _id_sticker;
    
	IF(_position = 0 OR _position = -1)
	  THEN
		SET _position = lastposition+1;
	END IF;
  
    IF NOT EXISTS(SELECT id_sticker FROM channels_stickers_related WHERE id_sticker = _id_sticker AND id_channel = _id_channel)
    THEN
        INSERT INTO channels_stickers_related(id_sticker,id_channel,position,begin_date,end_date,color,update_date,register_date) VALUES(_id_sticker,_id_channel,_position,_begin_date,_end_date,_color,now(),now());
        
			SET @rownum=0;
			UPDATE channels_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, channels_stickers_related.* FROM channels_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,register_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
    ELSE
        
		UPDATE channels_stickers_related SET position = _position, begin_date = _begin_date,end_date = _end_date,color = _color, update_date = now() WHERE id_sticker = _id_sticker AND id_channel = _id_channel;
        
		IF(_position < currentposition)
		 THEN   
         
			SET @rownum=0;
			UPDATE channels_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, channels_stickers_related.* FROM channels_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,update_date desc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
			INSERT into video_sync_updated_2(id_channel,action_type,register_date) SELECT id_channel,2,now() FROM collections 
        	WHERE id_channel in (SELECT distinct id_channel FROM channels_stickers_related WHERE id_sticker = _id_sticker AND position BETWEEN _position AND currentposition); 
            
		END IF;
        
        IF(_position > currentposition)
        THEN
        
			SET @rownum=0;
			UPDATE channels_stickers_related c, (SELECT @rownum:=@rownum+1 rownum, channels_stickers_related.* FROM channels_stickers_related WHERE id_sticker = _id_sticker ORDER BY position,update_date asc) r 
			SET c.position = r.rownum
			WHERE (c.id_related = r.id_related);
            
            INSERT into video_sync_updated_2(id_post,action_type,register_date) SELECT id_channel,2,now() FROM collections 
        	WHERE id_channel in (SELECT distinct id_channel FROM channels_stickers_related WHERE id_sticker = _id_sticker AND position BETWEEN currentposition AND _position); 
		END IF;
        
	END IF;
        
        SELECT 0 as return_code;

ELSE
    SELECT -2 as return_code;
END IF;
    
COMMIT;

END;

