<?php namespace Skoiy\Ott\Avatar;

class Query
{
    const ALL = 0;
    const NAME = 1;
    const ACTIVE = 2;
    const INACTIVE = 3;
    const BY_GROUP_ID_AND_NAME = 4;
    const USED_X_TIMES = 5;

    const ORDER_BY_NAME_ASC = 11000;
    const ORDER_BY_NAME_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    const ORDER_BY_GROUP_ID_ASC = 11002;
    const ORDER_BY_GROUP_ID_DESC = 10002;

    const ORDER_BY_TOTAL_SELECTED_ASC = 11003;
    const ORDER_BY_TOTAL_SELECTED_DESC = 10003;

    /**
     * @var
     */
    public $by = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $orderBy = 0;

    /**
     * @var
     */
    public $order = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }
}
