<?php

namespace Skoiy\Ott\Promotion;

class PromotionQuery implements Query
{
//    const ALL = 0;
    const NAME = 1;
//    const DESCRIPTION = 2;
//    const MONTH = 4;
//    const YEAR = 5;
//    const STATE = 6;

    const BY_ID_USER = 100;
    const BY_EMAIL = 101;
    const BY_ID_PLAN = 102;
    const BY_PLAN_NAME = 103;
    const BY_VERIFIED = 104;

    const ORDER_BY_NAME_ASC = 11000;
    const ORDER_BY_NAME_DESC = 10000;

    const ORDER_BY_REGISTER_DATE_ASC = 11001;
    const ORDER_BY_REGISTER_DATE_DESC = 10001;

    const ORDER_BY_ID_PLAN_ASC = 11002;
    const ORDER_BY_ID_PLAN_DESC = 10002;

    /**
     * @var
     */
    public $by = 0;

    /**
     * @var
     */
    public $sndBy = 0;

    /**
     * @var
     */
    public $trdBy = 0;

    /**
     * @var
     */
    public $term = "";

    /**
     * @var
     */
    public $filter = "";

    /**
     * @var
     */
    public $sndFilter = "";

    /**
     * @var
     */
    public $trdFilter = "";

    /**
     * @var
     */
    public $from = 0;

    /**
     * @var
     * If you pass $to=-1 the results will be from=FIRST_ROW to=LAST_ROW
     */
    public $to = 15;

    /**
     * @var
     */
    public $orderBy = 0;

    /**
     * @var
     */
    public $order = 0;

    public function __construct()
    {
    }

    public function __get($name)
    {
        return $this->$name;
    }

    public function __set($name, $value)
    {
        $this->$name = $value;
    }

}