<?php namespace Skoiy\Ott\Publish;

use Exception;
use PDO;
use Stage\Stage;

class Publish{

    /**
     * changed
     * Get all the objects to sync with couchdb
     * @return array
     * @throws Exception
     */
    public static function changed($page = 1, $perPage = 20)
    {
        $from = ($page-1) * $perPage;
        $to = $perPage;

        try {
            $name = "PUBLISH_OTT";
            $method = "GET";
            $parameters = [[$from, PDO::PARAM_INT],
                [$to, PDO::PARAM_INT]];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * publishEnd
     *
     * @return array
     * @throws Exception
     */
    public static function publishEnd()
    {
        try {
            $name = "PUBLISH_OTT_ENDS";
            $method = "SET";
            $parameters = [];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

    /**
     * publishStart
     *
     * Is doing some stuff in the table ott_publish_log
     * @return array
     * @throws Exception
     */
    public static function publishStart()
    {
        try {
            $name = "PUBLISH_OTT";
            $method = "SET";
            $parameters = [];

            $data = Stage::esp($parameters, $name, $method);
            return $data;
        } catch (Exception $e) {
            throw $e;
        }
    }

}