<?php namespace Skoiy\Ott;

class QueryResponse {

    public $data;
    public $totalResults;
    public $page;
    public $perPage;
    public $totalPages;
    public $lastPage;
    public $prevPage;
    public $currentPage;
    public $nextPage;

    public function __construct() {

    }

    /**
     * @param $results
     * @param $totalResults
     * @param $page
     * @param $paginator
     * @return QueryResponse
     */
    public static function create($results, $totalResults, $page, $paginator) {

        list($from, $to, $perPage, $currentPage, $prevPage, $nextPage, $totalPages) = $paginator;
        $response = new self();
        $response->data = $results;
        $response->totalResults = (int)$totalResults;
        $response->page = (int)$page;
        $response->totalPages = (int)$totalPages;
        $response->perPage = (int)$perPage;
        $response->nextPage = (int)$nextPage;
        $response->prevPage = (int)$prevPage;
        $response->lastPage = (int)$totalPages;
        $response->currentPage = (int)$currentPage;
        return $response;
    }
}