<?php
return [

    'get' => [
        'OTT_AVATAR' => ['name' => 'SP_GET_OTT_AVATAR', 'parameters' => [':id_avatar'], 'connection' => 'ott', 'event' => ''],
        'OTT_AVATARS' => ['name' => 'SP_GET_OTT_AVATARS', 'parameters' => [':field', ':query', ':filter', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_AVATARS_COUNT' => ['name' => 'SP_GET_OTT_AVATARS_COUNT', 'parameters' => [':field', ':query', ':filter'], 'connection' => 'ott', 'event' => ''],
        'OTT_AVATARS_GROUPS' => ['name' => 'SP_GET_OTT_AVATARS_GROUPS', 'parameters' => [':field', ':query', ':filter', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_AVATARS_GROUP' => ['name' => 'SP_GET_OTT_AVATARS_GROUP', 'parameters' => [':id_group'], 'connection' => 'ott', 'event' => ''],
        'OTT_AVATARS_NUM' => ['name' => 'SP_GET_OTT_AVATARS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_USER' => ['name' => 'SP_GET_OTT_USER', 'parameters' => [':id_user'], 'connection' => 'ott', 'event' => ''],
        'OTT_USERS' => ['name' => 'SP_GET_OTT_USERS', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_USERS_COUNT' => ['name' => 'SP_GET_OTT_USERS_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_USERS_NUM' => ['name' => 'SP_GET_OTT_USERS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_USERS_PERFORMANCE' => ['name' => 'SP_GET_OTT_USERS_PERFORMANCE', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':limit_trd_a', ':limit_trd_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN' => ['name' => 'SP_GET_OTT_PLAN', 'parameters' => [':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_ISOLANGUAGES' => ['name' => 'SP_GET_OTT_PLAN_ISOLANGUAGES', 'parameters' => [':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_L10N' => ['name' => 'SP_GET_OTT_PLAN_L10N', 'parameters' => [':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET' => ['name' => 'SP_GET_OTT_PLAN_SET', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_ISOLANGUAGES' => ['name' => 'SP_GET_OTT_PLAN_SET_ISOLANGUAGES', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_L10N' => ['name' => 'SP_GET_OTT_PLAN_SET_L10N', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_PLANS' => ['name' => 'SP_GET_OTT_PLAN_SET_PLANS', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_SECURITY_COUNTRIES' => ['name' => 'SP_GET_OTT_PLAN_SET_SECURITY_COUNTRIES', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SETS_NUM' => ['name' => 'SP_GET_OTT_PLAN_SETS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_PLANS_NUM' => ['name' => 'SP_GET_OTT_PLANS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION' => ['name' => 'SP_GET_OTT_PROMOTION', 'parameters' => [':id_promotion'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_PLANS' => ['name' => 'SP_GET_OTT_PROMOTION_PLANS', 'parameters' => [':id_promotion'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_SECURITY_COUNTRIES' => ['name' => 'SP_GET_OTT_PROMOTION_SECURITY_COUNTRIES', 'parameters' => [':id_promotion'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTIONS_NUM' => ['name' => 'SP_GET_OTT_PROMOTIONS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_PRICES' => ['name' => 'SP_GET_OTT_PLAN_PRICES', 'parameters' => [':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_CODES' => ['name' => 'SP_GET_OTT_PROMOTION_CODES', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':limit_a', ':limit_b', ':order_by', ':order'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_CODES_COUNT' => ['name' => 'SP_GET_OTT_PROMOTION_CODES_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_WHITELIST' => ['name' => 'SP_GET_OTT_PROMOTION_WHITELIST', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_WHITELIST_COUNT' => ['name' => 'SP_GET_OTT_PROMOTION_WHITELIST_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_USED' => ['name' => 'SP_GET_OTT_PROMOTION_USED', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_USED_COUNT' => ['name' => 'SP_GET_OTT_PROMOTION_USED_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTIONS' => ['name' => 'SP_GET_OTT_PROMOTIONS', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTIONS_COUNT' => ['name' => 'SP_GET_OTT_PROMOTIONS_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SETS' => ['name' => 'SP_GET_OTT_PLAN_SETS', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SETS_COUNT' => ['name' => 'SP_GET_OTT_PLAN_SETS_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLANS' => ['name' => 'SP_GET_OTT_PLANS', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLANS_COUNT' => ['name' => 'SP_GET_OTT_PLANS_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'PUBLISH_OTT' => ['name' => 'SP_GET_PUBLISH_OTT', 'parameters' => [':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'LANGUAGES' => ['name' => 'SP_GET_LANGUAGES', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'CURRENCIES' => ['name' => 'SP_GET_CURRENCIES', 'parameters' => [':lang'], 'connection' => 'ott', 'event' => ''],
        'COUNTRIES' => ['name' => 'SP_GET_COUNTRIES', 'parameters' => [':lang'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_CODE_NUM' => ['name' => 'SP_GET_OTT_PROMOTION_CODE_NUM', 'parameters' => [':code'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE' => ['name' => 'SP_GET_OTT_FREEBIE', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_COUNT' => ['name' => 'SP_GET_OTT_FREEBIES_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES' => ['name' => 'SP_GET_OTT_FREEBIES', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_ISOLANGUAGES' => ['name' => 'SP_GET_OTT_FREEBIES_ISOLANGUAGES', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_NUM' => ['name' => 'SP_GET_OTT_FREEBIES_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_CODES' => ['name' => 'SP_GET_OTT_FREEBIE_CODES', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_CODES_COUNT' => ['name' => 'SP_GET_OTT_FREEBIE_CODES_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_CODE_NUM' => ['name' => 'SP_GET_OTT_FREEBIE_CODE_NUM', 'parameters' => [':code'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_PLANS' => ['name' => 'SP_GET_OTT_FREEBIE_PLANS', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_SECURITY_COUNTRIES' => ['name' => 'SP_GET_OTT_FREEBIE_SECURITY_COUNTRIES', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_USED' => ['name' => 'SP_GET_OTT_FREEBIE_USED', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_USED_COUNT' => ['name' => 'SP_GET_OTT_FREEBIE_USED_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_WHITELIST' => ['name' => 'SP_GET_OTT_FREEBIE_WHITELIST', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_WHITELIST_COUNT' => ['name' => 'SP_GET_OTT_FREEBIE_WHITELIST_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_WHITELIST_ITEM' => ['name' => 'SP_GET_OTT_FREEBIE_WHITELIST_ITEM', 'parameters' => [':id'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_L10N' => ['name' => 'SP_GET_OTT_FREEBIES_L10N', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_USER_PLANS' => ['name' => 'SP_GET_OTT_USER_PLANS', 'parameters' => [':id_user', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_USER_PLANS_COUNT' => ['name' => 'SP_GET_OTT_USER_PLANS_COUNT', 'parameters' => [':id_user', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_USER_TRANSACTIONS' => ['name' => 'SP_GET_OTT_USER_TRANSACTIONS', 'parameters' => [':id_user', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_USER_TRANSACTIONS_COUNT' => ['name' => 'SP_GET_OTT_USER_TRANSACTIONS_COUNT', 'parameters' => [':id_user', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES' => ['name' => 'SP_GET_OTT_AUDIENCES', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_COMMAND' => ['name' => 'SP_GET_OTT_AUDIENCES_COMMAND', 'parameters' => [':id_audience'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_OPTIONS' => ['name' => 'SP_GET_OTT_AUDIENCES_OPTIONS', 'parameters' => [':field', ':option_type'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCE' => ['name' => 'SP_GET_OTT_AUDIENCE', 'parameters' => [':id_audience'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_GROUP_OPTIONS_RELATED' => ['name' => 'SP_GET_OTT_AUDIENCES_GROUP_OPTIONS_RELATED', 'parameters' => [':id_audience'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARD' => ['name' => 'SP_GET_OTT_LEADERBOARD', 'parameters' => [':id_leaderboard'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_COUNT' => ['name' => 'SP_GET_OTT_LEADERBOARDS_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS' => ['name' => 'SP_GET_OTT_LEADERBOARDS', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_ISOLANGUAGES' => ['name' => 'SP_GET_OTT_LEADERBOARDS_ISOLANGUAGES', 'parameters' => [':id_leaderboard'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_L10N' => ['name' => 'SP_GET_OTT_LEADERBOARDS_L10N', 'parameters' => [':id_leaderboard'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_NUM' => ['name' => 'SP_GET_OTT_LEADERBOARDS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_TEAMS_AVATARS' => ['name' => 'SP_GET_OTT_LEADERBOARDS_TEAMS_AVATARS', 'parameters' => [':id_leaderboard', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_USERS_AVATARS_COUNT' => ['name' => 'SP_GET_OTT_LEADERBOARDS_USERS_AVATARS_COUNT', 'parameters' => [':id_leaderboard', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_USERS_AVATARS' => ['name' => 'SP_GET_OTT_LEADERBOARDS_USERS_AVATARS', 'parameters' => [':id_leaderboard', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_USERS_COUNT' => ['name' => 'SP_GET_OTT_LEADERBOARDS_USERS_COUNT', 'parameters' => [':id_leaderboard', ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_USERS' => ['name' => 'SP_GET_OTT_LEADERBOARDS_USERS', 'parameters' => [':id_leaderboard',  ':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS' => ['name' => 'SP_GET_OTT_SCANS', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN_CODE_NUM' => ['name' => 'SP_GET_OTT_SCAN_CODE_NUM', 'parameters' => [':code'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN_CODES_COUNT' => ['name' => 'SP_GET_OTT_SCAN_CODES_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN_CODES' => ['name' => 'SP_GET_OTT_SCAN_CODES', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd', ':order_by', ':order', ':limit_a', ':limit_b'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN' => ['name' => 'SP_GET_OTT_SCAN', 'parameters' => [':id_scan'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS_COUNT' => ['name' => 'SP_GET_OTT_SCANS_COUNT', 'parameters' => [':field', ':field_snd', ':field_trd', ':query', ':filter', ':filter_snd', ':filter_trd'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS_ISOLANGUAGES' => ['name' => 'SP_GET_OTT_SCANS_ISOLANGUAGES', 'parameters' => [':id_scan'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS_L10N' => ['name' => 'SP_GET_OTT_SCANS_L10N', 'parameters' => [':id_scan'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS_NUM' => ['name' => 'SP_GET_OTT_SCANS_NUM', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
    ],
    'set' => [
        'OTT_USER' => ['name' => 'SP_SET_OTT_USER', 'parameters' => [':id_user', ':name', ':email', ':gender', ':birthdate', ':identification', ':tax_number', ':nationality', ':country_iso', ':address', ':city', ':zipcode', ':phone', ':active', ':verified'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN' => ['name' => 'SP_SET_OTT_PLAN', 'parameters' => [':id_plan', ':plan_type', ':management_name', ':name_stripped', ':billing_type', ':billing_cycle', ':first_bill_date', ':trial_active', ':trial_type', ':trial_period', ':trial_for_new_users', ':time_active', ':time_type', ':time_period', ':grace_active', ':grace_type', ':grace_period', ':unlimited_access', ':accept_pay_more', ':accept_pay_cycle', ':active', ':allow_promotions'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_CLONE' => ['name' => 'SP_SET_OTT_PLAN_CLONE', 'parameters' => [':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_L10N' => ['name' => 'SP_SET_OTT_PLAN_L10N', 'parameters' => [':id_l10n', ':id_plan', ':iso_language', ':name', ':description', ':details', ':action_name', ':action_target'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_PRICES' => ['name' => 'SP_SET_OTT_PLAN_PRICES', 'parameters' => [':id', ':id_plan', ':price', ':trial_price', ':currency_iso', ':is_default', ':position'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET' => ['name' => 'SP_SET_OTT_PLAN_SET', 'parameters' => [':id_plan_set', ':management_name', ':name_stripped', ':active', ':domains', ':exclude'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_CLONE' => ['name' => 'SP_SET_OTT_PLAN_SET_CLONE', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_SECURITY_COUNTRIES' => ['name' => 'SP_SET_OTT_PLAN_SET_SECURITY_COUNTRIES', 'parameters' => [':id_plan_set', ':country_iso', ':exclude'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_L10N' => ['name' => 'SP_SET_OTT_PLAN_SET_L10N', 'parameters' => [':id_l10n', ':id_plan_set', ':iso_language', ':name', ':description', ':details', ':action_name', ':action_target'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_PLANS_RELATED' => ['name' => 'SP_SET_OTT_PLAN_SET_PLANS_RELATED', 'parameters' => [':id_plan_set', ':id_plan', ':is_default', ':position'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION' => ['name' => 'SP_SET_OTT_PROMOTION', 'parameters' => [':id_promotion', ':promotion_type', ':percent_off', ':price_off', ':currency_iso', ':name', ':name_stripped', ':begin_date', ':end_date', ':applied_on_renewal', ':applied_to_all_periods', ':billing_period', ':code_required', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_CLONE' => ['name' => 'SP_SET_OTT_PROMOTION_CLONE', 'parameters' => [':id_promotion'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_CODES_RELATED' => ['name' => 'SP_SET_OTT_PROMOTION_CODES_RELATED', 'parameters' => [':id_code', ':id_promotion', ':code', ':quantity', ':unlimited', ':active', ':searchable', ':random_code', ':prefix', ':numbers', ':lowercase', ':uppercase', ':length', ':total_codes'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_COUNTRIES' => ['name' => 'SP_SET_OTT_PROMOTION_SECURITY_COUNTRIES', 'parameters' => [':id_promotion', ':country_iso', ':exclude'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_PLANS_RELATED' => ['name' => 'SP_SET_OTT_PROMOTION_PLANS_RELATED', 'parameters' => [':id_promotion', ':id_plan', ':position'], 'connection' => 'ott', 'event' => ''],
        'PUBLISH_OTT_ENDS' => ['name' => 'SP_SET_PUBLISH_OTT_ENDS', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'PUBLISH_OTT' => ['name' => 'SP_SET_PUBLISH_OTT', 'parameters' => [], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_WHITELIST_RELATED' => ['name' => 'SP_SET_OTT_PROMOTION_WHITELIST_RELATED', 'parameters' => [':id', ':id_promotion', ':email', ':type', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE' => ['name' => 'SP_SET_OTT_FREEBIE', 'parameters' => [':id', ':name', ':name_stripped', ':begin_date', ':end_date', ':applied_to_all_periods', ':billing_period', ':one_use_per_user', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_CODES_RELATED' => ['name' => 'SP_SET_OTT_FREEBIES_CODES_RELATED', 'parameters' => [':id_code', ':id_freebie', ':code', ':quantity', ':unlimited', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_SECURITY_COUNTRIES' => ['name' => 'SP_SET_OTT_FREEBIES_SECURITY_COUNTRIES', 'parameters' => [':id_freebie', ':country_iso', ':exclude'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_L10N' => ['name' => 'SP_SET_OTT_FREEBIES_L10N', 'parameters' => [':id_l10n', ':id_freebie', ':iso_language', ':name', ':description', ':details', ':action_name', ':action_target'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_PLANS_RELATED' => ['name' => 'SP_SET_OTT_FREEBIES_PLANS_RELATED', 'parameters' => [':id_freebie', ':id_plan', ':position'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIES_WHITELIST_RELATED' => ['name' => 'SP_SET_OTT_FREEBIES_WHITELIST_RELATED', 'parameters' => [':id', ':id_freebie', ':value', ':type', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_CLONE' => ['name' => 'SP_SET_OTT_FREEBIE_CLONE', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'AUDIENCES_CREATE_COMMAND' => ['name' => 'SP_SET_AUDIENCES_CREATE_COMMAND', 'parameters' => [':id_audience'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCE' => ['name' => 'SP_SET_OTT_AUDIENCE', 'parameters' => [':id_audience', ':name'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_GROUP' => ['name' => 'SP_SET_OTT_AUDIENCES_GROUP', 'parameters' => [':id_group', ':id_audience', ':operator_type'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_GROUP_OPTIONS_RELATED' => ['name' => 'SP_SET_OTT_AUDIENCES_GROUP_OPTIONS_RELATED', 'parameters' => [':id_group', ':id_audience', ':id_option', ':option_value'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS' => ['name' => 'SP_SET_OTT_LEADERBOARDS', 'parameters' => [':id_leaderboard', ':name', ':name_stripped', ':allow_teams', ':allow_friends', ':allow_optimize_results', ':max_users_per_team', ':total_teams_per_user', ':max_friends_per_user', ':max_optimization_attempts', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARD_L10N' => ['name' => 'SP_SET_OTT_LEADERBOARD_L10N', 'parameters' => [':id_l10n', ':id_leaderboard', ':iso_language', ':singular_unit', ':plural_units'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_TEAMS_AVATARS' => ['name' => 'SP_SET_OTT_LEADERBOARDS_TEAMS_AVATARS', 'parameters' => [':id_avatar', ':id_leaderboard', ':name', ':id_asset', ':fname', ':avatar', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_LEADERBOARDS_USERS_AVATARS' => ['name' => 'SP_SET_OTT_LEADERBOARDS_USERS_AVATARS', 'parameters' => [':id_avatar', ':id_leaderboard', ':name', ':id_asset', ':fname', ':avatar', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS' => ['name' => 'SP_SET_OTT_SCANS', 'parameters' => [':id_scan', ':management_name', ':scan_type', ':start_date', ':end_date', ':active'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCANS_L10N' => ['name' => 'SP_SET_OTT_SCANS_L10N', 'parameters' => [':id_l10n', ':id_scan', ':iso_language', ':name', ':name_stripped', ':description', ':image'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN_CODES_RELATED' => ['name' => 'SP_SET_OTT_SCAN_CODES_RELATED', 'parameters' => [':id_code', ':id_scan', ':code', ':quantity', ':unlimited', ':active', ':max_scans_per_user', ':daily_limit_per_user', ':scan_interval_per_user', ':random_code', ':prefix', ':numbers', ':lowercase', ':uppercase', ':length', ':total_codes'], 'connection' => 'ott', 'event' => ''],
    ],
    'del' => [
        'OTT_PLAN' => ['name' => 'SP_DEL_OTT_PLAN', 'parameters' => [':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_L10N' => ['name' => 'SP_DEL_OTT_PLAN_L10N', 'parameters' => [':id_l10n'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET' => ['name' => 'SP_DEL_OTT_PLAN_SET', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_L10N' => ['name' => 'SP_DEL_OTT_PLAN_SET_L10N', 'parameters' => [':id_l10n'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SET_SECURITY_COUNTRIES' => ['name' => 'SP_DEL_OTT_PLAN_SET_SECURITY_COUNTRIES', 'parameters' => [':id_plan_set'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_SETS_PLAN' => ['name' => 'SP_DEL_OTT_PLAN_SETS_PLAN', 'parameters' => [':type', ':id_plan_set', ':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION' => ['name' => 'SP_DEL_OTT_PROMOTION', 'parameters' => [':id_promotion'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_CODE' => ['name' => 'SP_DEL_OTT_PROMOTION_CODE', 'parameters' => [':type', ':id_promotion', ':id_code'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_PLAN' => ['name' => 'SP_DEL_OTT_PROMOTION_PLAN', 'parameters' => [':type', ':id_promotion', ':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_SECURITY_COUNTRIES' => ['name' => 'SP_DEL_OTT_PROMOTION_SECURITY_COUNTRIES', 'parameters' => [':id_promotion'], 'connection' => 'ott', 'event' => ''],
        'OTT_PLAN_PRICES' => ['name' => 'SP_DEL_OTT_PLAN_PRICES', 'parameters' => [':type', ':id_plan', ':id'], 'connection' => 'ott', 'event' => ''],
        'OTT_PROMOTION_WHITELIST' => ['name' => 'SP_DEL_OTT_PROMOTION_WHITELIST', 'parameters' => [':type', ':id_promotion', ':email'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE' => ['name' => 'SP_DEL_OTT_FREEBIE', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_CODE' => ['name' => 'SP_DEL_OTT_FREEBIE_CODE', 'parameters' => [':type', ':id_freebie', ':id_code'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_L10N' => ['name' => 'SP_DEL_OTT_FREEBIE_L10N', 'parameters' => [':id_l10n'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_PLAN' => ['name' => 'SP_DEL_OTT_FREEBIE_PLAN', 'parameters' => [':type', ':id_freebie', ':id_plan'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_SECURITY_COUNTRIES' => ['name' => 'SP_DEL_OTT_FREEBIE_SECURITY_COUNTRIES', 'parameters' => [':id_freebie'], 'connection' => 'ott', 'event' => ''],
        'OTT_FREEBIE_WHITELIST' => ['name' => 'SP_DEL_OTT_FREEBIE_WHITELIST', 'parameters' => [':type', ':id_freebie', ':id'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_GROUP_OPTION_RELATED' => ['name' => 'SP_DEL_OTT_AUDIENCES_GROUP_OPTION_RELATED', 'parameters' => [':id_group', ':id_audience', ':id_option'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCE' => ['name' => 'SP_DEL_OTT_AUDIENCE', 'parameters' => [':id_audience'], 'connection' => 'ott', 'event' => ''],
        'OTT_AUDIENCES_GROUP' => ['name' => 'SP_DEL_OTT_AUDIENCES_GROUP', 'parameters' => [':id_audience', ':id_group'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN_CODE' => ['name' => 'SP_DEL_OTT_SCAN_CODE', 'parameters' => [':type', ':id_scan', ':id_code'], 'connection' => 'ott', 'event' => ''],
        'OTT_SCAN' => ['name' => 'SP_DEL_OTT_SCAN', 'parameters' => [':id_scan'], 'connection' => 'ott', 'event' => ''],
    ]

];
